SUB Indiktion(JD&, Graceae%, Bedana%, Romana%, RomanaA%)
  'Graceae = 1. Sept.
  'Bedana = 24. Sept.
  'RomanaA = 25. Dez.
  'Romana = 1. Jan.
  CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
  Romana% = (Jahr& + 3) MOD 15: IF Romana% = 0 THEN Romana% = 15
  IF Monat% > 8 THEN Graceae% = Romana% + 1 ELSE Graceae% = Romana%
  IF Graceae% = 16 THEN Graceae% = 1
  IF Monat% > 9 OR Monat% = 9 AND Tag% > 23 THEN Bedana% = Romana% + 1 ELSE Bedana% = Romana%
  IF Bedana% = 16 THEN Bedana% = 1
  IF Monat% = 12 AND Tag% > 24 THEN RomanaA% = Romana% + 1 ELSE RomanaA% = Romana%
  IF RomanaA% = 16 THEN RomanaA% = 1
END SUB

SUB Differenzdaten(Aktuell&, Diff$)
  Summe& = Aktuell& - Differenz&
  CALL JultageGregdatum (Differenz&, dTag%, dMonat%, dJahr&)
  CALL JultageGregdatum (Aktuell&, aTag%, aMonat%, aJahr&)
  IF dJahr& < 0 AND aJahr& > 0 THEN dJahr& = dJahr& + 1 'Das Jahr 0
  IF dJahr& > 0 AND aJahr& < 0 THEN dJahr& = dJahr& - 1 '   "
  IF Summe& < 0 THEN
    Jahre& = dJahr& - aJahr&
    Monate% = dMonat% - aMonat%
    Tage% = dTag% - aTag%
  ELSE
    Jahre& = aJahr& - dJahr&
    Monate% = aMonat% - dMonat%
    Tage% = aTag% - dTag%
  END IF
  IF Tage% < 0 THEN Tage% = Tage% + Monatstage(dMonat%): Monate% = Monate% - 1
  IF Monate% < 0 THEN Monate% = Monate% + 12: Jahre& = Jahre& - 1
  IF Jahre& = 1 THEN j$ = " Jahr" ELSE j$ = " Jahre"
  IF Monate% = 1 THEN m$ = " Monat" ELSE m$ = " Monate"
  IF Tage% = 1 THEN t$ = " Tag" ELSE t$ = " Tage"
  Diff$ = STR$(Jahre&) + j$ + STR$(Monate%) + m$ + STR$(Tage%) + t$
  IF Summe& < 0 THEN Diff$ = "-" + Diff$
END SUB

SUB JuedischMolad(JD&, Molad$)
 'Der Molad Tischri 1 ist am 29. Elul 0 um 23 Uhr 11 Min. 20 Sek. (MEZ)
 'JD = 347997.424537037 (bei Tagesbeginn 12.00 Uhr)
  JDM# = 347997.424537037 + INT((JD& - 347997) / 29.530594135) * 29.530594135
  CALL JulTageZeit (JDM#, Sekunde%, Minute%, Stunde%, JDT&)
  IF JD& = JDT& THEN
    s$ = LTRIM$(STR$(Sekunde%)): IF LEN(s$) = 1 THEN s$ = "0" + s$
    Molad$ = "Molad um " + USING$("##.##_.", Stunde% + Minute% / 100) + s$ +" Uhr"
  ELSE
    Molad$ = ""
  END IF
END SUB

SUB JulTageEingabe (Text$, Datum$, JD&, Typ%, Test%)
  'Typ%=0 Jul. Tage, =1 Mod. Jul. Tage
 IF Typ% = 1 THEN Modus& = -2400001 ELSE Modus& = 0
 DO
   Test% = 0
   CALL Texteingabe_t (Datum$, sz$, Text$, 7)
   IF sz$ = CHR$(27) THEN EXIT SUB
   JuTage& = VAL(Datum$)
   IF JuTage& > 3218554 + Modus& THEN a$ = "89" : Test% = 5
   IF JuTage& < -458510 + Modus& THEN a$ = "90" : Test% = 6
   IF Test% <> 0 THEN CALL Fehlermeldung(a$)
 LOOP UNTIL Test% = 0 OR sz$ = CHR$(27)
 IF sz$ <> CHR$(27) THEN
   IF Typ% = 1 THEN JD& = JuTage& - Modus& ELSE JD& = JuTage&
 END IF
 Test% = 1
END SUB

SUB JulianischerJahresanfang
 Nummer% = JulJahrAnfang%
 CALL diawin (2, Spalte%, 14, 47, " Julianischer Jahresanfang ", %ON)
 a$ = "Circumcision 1. Januar:Vorcsarisch (Rmisch) 1. Mrz:Annunciation (Pisa) bis 24. Mrz:Annunciation (Florenz) ab 25. Mrz:Pascha (Ostern) 22. Mrz - 25. April:"
 a$ = a$ + "Byzantinisch 1. September:Geburtstag des Augustus 23. September :Nativitt (Weihnachten) 25. Dezember"
 CALL diaradio (2, 2, " ", 2, 2, a$, Nummer%)
 CALL diapush (11, 32, "bernehmen")
 CALL diapush (11, 19, "Info")
 CALL diapush (11, 2, "Abbruch")
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 4 THEN EXIT LOOP
   IF d% = 3 THEN CALL LeseDateiName(DN_INFO$, 50, Infodatei$): CALL Kalenderinfo
   IF l% = %ENTER OR d% = 2 THEN JulJahrAnfang% = Nummer%: AeraJulian& = 1721424: EXIT LOOP
 LOOP
 CALL diaclose: mouseon
END SUB

SUB JulJahresanfang(Tag%, Monat%, Jahr&)
  SELECT CASE JulJahrAnfang%
  CASE 2
    'Vorcsarisch
    IF Monat% < 3 THEN Jahr& = Jahr& - 1
  CASE 3
    'Annunciationsstil bis 24.3.
    IF Monat% > 3 OR Monat% = 3 AND Tag% > 24 THEN Jahr& = Jahr& + 1
  CASE 4
    'Calculus Florentinus ab 25.3.
    IF Monat% < 3 OR Monat% = 3 AND Tag% < 25 THEN Jahr& = Jahr& - 1
  CASE 5
    'Paschastil
    CALL OstersonntagJul(Jahr&, Ostersonntag%)
    CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", JDO&, 0)
    CALL JultageJuldatum (JDO& + Ostersonntag%, TagO%, MonatO%, 0)
    IF Monat% < MonatO% OR Monat% = MonatO% AND Tag% < TagO% THEN Jahr& = Jahr& - 1
  CASE 6
    'Byzantinisch
    IF Monat% < 9 THEN Jahr& = Jahr& - 1
  CASE 7
    'Geburtstag des Augustus
    IF Monat% > 9 OR Monat% = 9 AND Tag% > 22 THEN Jahr& = Jahr& + 1
  CASE 8
    'Nativittsstil 25.12.
    IF Monat% = 12 AND Tag% > 24 THEN Jahr& = Jahr& + 1
  END SELECT
  IF Jahr& = 0 THEN Jahr& = -1
END SUB

SUB JulianischeEpoche
 diainputsize% = 8 'sichbare Eingabelnge
 Julian$ = LTRIM$(STR$(AeraJulian&)): mat& = AeraJulian&
 SELECT CASE AeraJulian&
   CASE -458510 : Nummer% = 1
   CASE -290495 : Nummer% = 2
   CASE 0       : Nummer% = 3
   CASE 1438171 : Nummer% = 4
   CASE 1446501 : Nummer% = 5
   CASE 1607739 : Nummer% = 6
   CASE 1707544 : Nummer% = 7
   CASE 1721424 : Nummer% = 8
   CASE ELSE : Nummer% = 9
 END SELECT

 CALL diawin (2, Spalte%, 18, 37, " Julianische ra ", %ON)
 a$="Antiochisch:Byzantisch:Scaliger, Julianisch:Olympisch:Varronisch, ab urbe condita :Seleukiden, Tempel:Aszophar, Spanisch:Christlich:Andere ra"
 CALL diaradio (2, 2, "Auswahl verschiedener ren", 3, 2, a$, Nummer%)
 CALL diainp (13, 2, "Andere ra (JD):", 13, 19, 8, Julian$)
 CALL diapush (15, 2, "Abbruch")
 CALL diapush (15, 22, "bernehmen")
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 3 THEN AeraJulian& = mat&: CALL diaclose: mouseon: EXIT SUB
   IF d% = 1 THEN
     SELECT CASE Nummer%
       CASE 1: AeraJulian& = -458510
       CASE 2: AeraJulian& = -290495
       CASE 3: AeraJulian& = 0
       CASE 4: AeraJulian& = 1438171
       CASE 5: AeraJulian& = 1446501
       CASE 6: AeraJulian& = 1607739
       CASE 7: AeraJulian& = 1707544
       CASE 8: AeraJulian& = 1721424
     END SELECT
     Julian$ = LTRIM$(STR$(AeraJulian&)): diaset(2)
   ELSEIF d% = 4 OR (d% = 2 AND l% = %ENTER) THEN
     AeraJulian& = VAL(Julian$)
     IF Julian$ = "" THEN CALL Fehlermeldung ("91"): Test% = 1
     IF AeraJulian& < -458510 THEN CALL Fehlermeldung ("92"): Test% = 1
     IF AeraJulian& > 3218554 THEN CALL Fehlermeldung ("93"): Test% = 1
     IF Test% <> 0 THEN CALL diaset(3) ELSE JulJahrAnfang% = 0: CALL diaclose: mouseon: EXIT SUB
   END IF
 LOOP
END SUB

SUB Gauss (Jahr&, JD&)
  'bergibt den 15.Nissan als JD
 dyear# = Jahr& + 3760#
 IF Jahr& + 3760# < 3761# THEN dyear# = dyear# + 1    'Das Jahr 0 wegrechnen

 da# = (12# * dyear# +17#) MOD 19#
 db# = dyear# MOD 4#
 dm# = 32# +4343# / 98496# + da# + da# * (272953# / 492480#) + db# / 4#
 dm# = dm# - dyear# * (313# / 98496#)
 dmfrac# = dm# - INT(dm#)

  'determine the postponement
 dc# = (3# * dyear# +5# * db# + INT(dm#) +5#) MOD 7#
 IF dc# = 2# OR dc# = 4# OR dc# = 6# THEN dm# = dm# +1#
 IF dc# = 1# AND da# > 6# AND dmfrac# >= 1367# / 2160# THEN dm# = dm# +2#
 IF dc# = 0# AND da# > 11# AND dmfrac# >= 23269# / 25920# THEN dm# = dm# +1#

 Tag% = INT(dm#)
 Monat% = 3
 IF Tag% > 153# THEN Monat% = 8 : Tag% = Tag% -153#
 IF Tag% > 122# THEN Monat% = 7 : Tag% = Tag% -122#
 IF Tag% > 92# THEN Monat% = 6 : Tag% = Tag% -92#
 IF Tag% > 61# THEN Monat% = 5 : Tag% = Tag% -61#
 IF Tag% > 31# THEN Monat% = 4 : Tag% = Tag% -31#

 'CALL JuldatumJultage (Tag%, Monat%, Jahr&, JD&)
 CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "EJ", JD&, 0)
END SUB

SUB JultageAegypt (JD&, AeTag%, AeMonat%, AeJahr&, Sothis%)
 a& = JD& - AeraAegytisch&
 Sothis% = INT((JD& - 172598) / 533265) + 1
 AeJahr& = INT(a& / 365) + 1
 a& = a& - (AeJahr& - 1) * 365
 AeMonat% = INT(a& / 30) + 1
 AeTag% = a& - AeMonat% * 30 + 31
 IF AeJahr& < 1 THEN AeJahr& = AeJahr& -1
END SUB

SUB AegyptischeEpoche
 diainputsize% = 8 'sichbare Eingabelnge
 Agypt$ = LTRIM$(STR$(AeraAegytisch&)): mat& = AeraAegytisch&
 SELECT CASE AeraAegytisch&
 CASE 172598 : Nummer% = 1 'gyptische ra
 CASE 1448638 : Nummer% = 2 'Nabonassar
 CASE 1603398 : Nummer% = 3 'Alexander, Philipp
 CASE 1922868 : Nummer% = 4 'Armenisch
 CASE 1952063 : Nummer% = 5 'Altpersisch
 CASE ELSE : Nummer% = 6
 END SELECT

 CALL diawin (2, Spalte%, 15, 31, " gyptische ra ", %ON)
 a$="gyptisch:Nabonassar(Ptolemus):Alexander, Philipp:Armenisch:Jazdagird, Altpersisch:Andere ra"
 CALL diaradio (2, 2, "Auswahl verschiedener ren", 3, 2, a$, Nummer%)
 CALL diainp (10, 2, "Andere ra (JD):", 10, 20, 8, Agypt$)
 CALL diapush (12, 2, "Abbruch")
 CALL diapush (12, 16, "bernehmen")
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 3 THEN AeraAegytisch& = mat&: CALL diaclose: mouseon: EXIT SUB
   IF d% = 1 THEN
     SELECT CASE Nummer%
     CASE 1: AeraAegytisch& = 172598
     CASE 2: AeraAegytisch& = 1448638
     CASE 3: AeraAegytisch& = 1603398
     CASE 4: AeraAegytisch& = 1922868
     CASE 5: AeraAegytisch& = 1952063
     END SELECT
     Agypt$ = LTRIM$(STR$(AeraAegytisch&)): diaset(2)
   ELSEIF d% = 4 OR (d% = 2 AND l% = %ENTER) THEN
     AeraAegytisch& = VAL(Agypt$)
     IF Agypt$ = "" THEN CALL Fehlermeldung ("91"): Test% = 1
     IF AeraAegytisch& < -458510 THEN CALL Fehlermeldung ("92"): Test% = 1
     IF AeraAegytisch& > 3218554 THEN CALL Fehlermeldung ("93"): Test% = 1
     IF Test% <> 0 THEN CALL diaset(3): ELSE CALL diaclose: mouseon: EXIT SUB
   END IF
 LOOP
END SUB

SUB KoptischeEpoche
 diainputsize% = 8 'sichbare Eingabelnge
 Kopt$ = LTRIM$(STR$(AeraKoptisch&)): mat& = AeraKoptisch&
 SELECT CASE AeraKoptisch&
 CASE -284654: Nummer% = 1 'Pandorus
 CASE 1825029: Nummer% = 2 'Diokletian
 CASE ELSE: Nummer% = 3
 END SELECT

 CALL diawin (2, Spalte%, 12, 34, " Koptische ra ", %ON)
 a$="Pandorus, Alexandrinisch :Diokletian, Mrtyrer:Andere ra"
 CALL diaradio (2, 2, "Auswahl verschiedener ren", 3, 2, a$, Nummer%)
 CALL diainp (7, 2, "Andere ra (JD):", 7, 20, 8, Kopt$)
 CALL diapush (9, 2, "Abbruch")
 CALL diapush (9, 19, "bernehmen")
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 3 THEN AeraKoptisch& = mat&: CALL diaclose: mouseon: EXIT SUB
   IF d% = 1 THEN
     SELECT CASE Nummer%
     CASE 1: AeraKoptisch& = -284654
     CASE 2: AeraKoptisch& = 1825029
     END SELECT
     Kopt$ = LTRIM$(STR$(AeraKoptisch&)): diaset(2)
   ELSEIF d% = 4 OR (d% = 2 AND l% = %ENTER) THEN
     AeraKoptisch& = VAL(Kopt$)
     IF Kopt$ = "" THEN CALL Fehlermeldung ("91"): Test% = 1
     IF AeraKoptisch& < -458510 THEN CALL Fehlermeldung ("92"): Test% = 1
     IF AeraKoptisch& > 3218554 THEN CALL Fehlermeldung ("93"): Test% = 1
     IF Test% <> 0 THEN CALL diaset(3): ELSE CALL diaclose: mouseon: EXIT SUB
   END IF
 LOOP
END SUB

SUB JultageArmenisch (JD&, ArTag%, ArMonat%, ArJahr&)
 AeraArmenisch& = 1922868
 a& = JD& - AeraArmenisch&
 ArJahr& = INT(a& / 365) + 1
 a& = a& - (ArJahr& - 1) * 365
 ArMonat% = INT(a& / 30) + 1
 ArTag% = a& - ArMonat% * 30 + 31
 IF ArJahr& < 1 THEN ArJahr& = ArJahr& -1
END SUB

SUB JultageJazdagird (JD&, JzTag%, JzMonat%, JzJahr&)
 AeraJazdagird& = 1952063
 IF JD& < 2088968 THEN korr% = 120 ELSE korr% = 0 'Epagomenen im 9. Monat
 a& = JD& - AeraJazdagird& + korr%
 JzJahr& = INT(a& / 365) + 1
 a& = a& - (JzJahr& - 1) * 365
 JzMonat% = INT(a& / 30) + 1
 JzTag% = a& - JzMonat% * 30 + 31
 IF korr% THEN
   JzMonat% = JzMonat% - 4
   IF JzMonat% < 1 THEN JzMonat% = JzMonat% + 13: JzJahr& = JzJahr& - 1
 END IF
 IF JzJahr& < 1 THEN JzJahr& = JzJahr& - 1
END SUB

SUB JultageGelal (JD&, Tag%, Monat%, Jahr&)
 AeraGelal& = 2115235
 a& = JD& - AeraGelal&
 Jahr& = INT(a& / 22645) * 62: a& = a& - INT(a& / 22645) * 22645 'Den 62 Jahre Zyklus abziehen
 IF a& = 21184 THEN mt% = 365 'Das 58. Jahr im Zyklus ist kein Schaltjahr, der letzte Tag ist der 5.
 IF a& >= 10592 THEN
   Jahr& = Jahr& + INT(a& / 10592) * 29: a& = a& - INT(a& / 10592) * 10592   'Den 29 Jahre Zyklus abziehen
   IF a& >= 11687 THEN
     Jahr& = Jahr& + INT(a& / 11687) * 32: a& = a& - INT(a& / 11687) * 11687 '32 Jahre mit alle vier Jahre Schaltjahre abziehen
     IF a& = 0 THEN a& = 365: Jahr& = Jahr& - 1
   END IF
 ELSE
   IF a& >= 10226 THEN
     Jahr& = Jahr& + INT(a& / 10226) * 28: a& = a& - INT(a& / 10226) * 10226   '28 Jahre mit alle vier Jahre Schaltjahre abziehen
     IF a& = 0 THEN a& = 365: Jahr& = Jahr& - 1
   END IF
 END IF
 IF a& >= 1461 THEN Jahr& = Jahr& + INT(a& / 1461) * 4: a& = a& - INT(a& / 1461) * 1461 'Den 4 Jahres Zyklus  abziehen
 IF a& = 0 THEN
   a& = 366: Jahr& = Jahr& - 1
   IF mt% THEN a& = mt%
 ELSE
   IF a& >= 365 THEN Jahr& = Jahr& + INT(a& / 365): a& = a& - INT(a& / 365) * 365 'Den Jahres Zyklus abziehen
   IF a& = 0 THEN a& = 365: Jahr& = Jahr& - 1
 END IF
 Tag% = a&
 Monat% = INT(Tag% / 30) + 1
 Tag% = Tag% - INT(Tag% / 30) * 30
 IF Tag% = 0 THEN Tag% = 30: Monat% = Monat% - 1
 IF Jahr& > -1 THEN Jahr& = Jahr& + 1
END SUB

SUB JultageKurdisch(JD&, Tag%, Monat%, Jahr&)
  CALL JultageKhayam(JD&, Tag%, Monat%, Jahr&)
  Jahr& = Jahr& + 1321
END SUB

SUB JultageKhayam(JD&, Tag%, Monat%, Jahr&)
 AeraKhayam& = 1948321
 CALL Jahreszeit (JD&, JDE#, 0, 3)
 IF INT(JDE# + 3.5 / 24) >= JD& THEN CALL Jahreszeit (JD& - 365, JDE#, 0, 3)
 JDA& = INT(JDE# + 3.5 / 24) 'Am Nachmittag Teheraner Zeit kein Neujahr mehr
 Tag% = JD& - JDA&
 Jahr& = INT((JD& - (Tag% - 182) - AeraKhayam&) / 365.2421875)
 IF Tag% <= 186 THEN
   Monat% = INT((JD& - JDA&) / 31) + 1
   Tag% = JD& - JDA& - Monat% * 31 + 31
   IF Tag% = 0 THEN Tag% = 31: Monat% = Monat% - 1
 ELSE
   Monat% = INT((JD& - JDA& - 186) / 30) + 7
   Tag% = JD& - JDA& - 186 - (Monat% - 7) * 30
   IF Tag% = 0 THEN Tag% = 30: Monat% = Monat% - 1
 END IF
 IF Jahr& >= 0 THEN Jahr& = Jahr& + 1
END SUB

SUB JultageBadidatum (JD&, BaTag%, BaMonat%, BaJahr&, Vahid%, Kull%)
 CALL JultageGregorian (JD&, Tag%, Monat%, Jahr&)
 BaJahr& = Jahr& - 1843
 'CALL GregorianJultage (21, 3, Jahr&, JDA&)
 CALL DatumEingabeUmrechnen(21, 3, Jahr&, "EI", JDA&, 0)
 'IF JDA& > JD& THEN CALL GregorianJultage (21, 3, Jahr& - 1, JDA&): BaJahr& = BaJahr& - 1
 IF JDA& > JD& THEN CALL DatumEingabeUmrechnen(21, 3, Jahr& - 1, "EI", JDA&, 0): BaJahr& = BaJahr& - 1

 BaTag% = JD& - JDA&: BaMonat% = 1: mt% = 19
 BaMonat% = INT(BaTag% / 19) + 1: BaTag% = BaTag% - INT(BaTag% / 19) * 19 + 1
 IF (Jahr& MOD 4 = 0 AND Jahr& MOD 100 <> 0) OR Jahr& MOD 400 = 0 THEN mt% = 5 ELSE mt% = 4
 'Tausch der Monate 19 und 20
 IF BaMonat% = 20 THEN
   BaTag% = BaTag% - mt% + 19
 ELSEIF BaMonat% = 19 AND BaTag% > mt% THEN
   BaMonat% = BaMonat% + 1: BaTag% = BaTag% - mt%
 END IF
 IF BaJahr& < 1 THEN
   Vahid% = ABS(FIX(BaJahr& / 19) - 1): WHILE Vahid% > 19: Vahid% = Vahid% / 19: WEND
   Kull% = ABS(FIX((BaJahr&) / 361) - 1)
   BaJahr& = BaJahr& - 1
 ELSE
   Vahid% = INT(BaJahr& / 19) + 1: WHILE Vahid% > 19: Vahid% = Vahid% / 19: WEND
   Kull% = INT(BaJahr& / 361) + 1
 END IF
END SUB

SUB JultageFranzdatum (JD&, Tag%, Monat%, Jahr&)
 '0064722 = Pariser Ortszeit
 AeraFranz& = 2375839
 CALL Jahreszeit (JD&, JDE#, 0, 9)
 IF INT(JDE# - .5 - .0064722) >= JD& THEN CALL Jahreszeit (JD& - 365, JDE#, 0, 9)
 Tag% = JD& - INT(JDE# - .5 - .0064722)
 Jahr& = INT((JD& - (Tag% - 182) - AeraFranz&) / 365.2421875)
 Monat% = INT(Tag% / 30) + 1
 Tag% = Tag% - INT(Tag% / 30) * 30
 IF Tag% = 0 THEN Tag% = 30: Monat% = Monat% - 1
 IF Jahr& >= 0 THEN Jahr& = Jahr& + 1
END SUB

SUB JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
 IF JD& < JDJulGreg& THEN
   CALL JultageJuldatum (JD&, Tag%, Monat%, Jahr&)
 ELSE
   CALL JultageGregorian (JD&, Tag%, Monat%, Jahr&)
 END IF
END SUB

SUB JultageGregorian (JD&, Tag%, Monat%, Jahr&)
 Merke% = Monatstage%(2)
 AeraGregorian& = 1721425 '= 31.12.-1
 Monatstage%(2) = 28
 a& = JD& - AeraGregorian&
 Jahr& = INT(a& / 146097) * 400            '400 Jahre Zyklus
 a& = a& - INT(a& / 146097) * 146097
 IF a& = 0 THEN
   a& = 366: Jahr& = Jahr& - 1
 ELSE
   Jahr& = Jahr& + INT(a& / 36524) * 100   '100 Jahre Zyklus
   a& = a& - INT(a& / 36524) * 36524
   IF a& = 0 THEN
      a& = 365: Jahr& = Jahr& - 1          'letztes Jahr des 100er Zyklus ist kein Schaltjahr
   ELSE
      Jahr& = Jahr& + INT(a& / 1461) * 4   '4 Jahre Zyklus
      a& = a& - INT(a& / 1461) * 1461
      IF a& = 0 THEN
        a& = 366: Jahr& = Jahr& - 1
      ELSE
        Jahr& = Jahr& + INT(a& / 365)      'Volle Normaljahre
        a& = a& - INT(a& / 365) * 365
        IF a& = 0 THEN a& = 365: Jahr& = Jahr& -1
      END IF
   END IF
 END IF
 IF Jahr& >-1 THEN Jahr& = Jahr& + 1: n% = 0 ELSE n% = -1 'n% fr die Schaltjahre v. Chr. (-1, -5 ...)
 Monat% = 0
 DO
   IF a& > mt% THEN a& = a& - mt%
   Monat% = Monat% + 1
   mt% = Monatstage%(Monat%)
   IF mt% = 28 THEN
     IF Jahr& MOD   4 = n% THEN mt% = 29
     IF Jahr& MOD 100 = n% THEN mt% = 28
     IF Jahr& MOD 400 = n% THEN mt% = 29
   END IF
 LOOP WHILE a& > mt%
 Tag% = a&
 Monatstage%(2) = Merke%
END SUB

SUB JultageKoptdatum (JD&, Tag%, Monat%, Jahr&)
  'Aus den Julianischen Tagen das Julianische Datum
 JT& = JD& - AeraKoptisch& + 364
 Jahr& = INT(JT& / 365.25)
 JT& = JT& - Jahr& * 365 - INT(Jahr& / 4)
 Monat% = INT (JT& / 30) + 1
 Tag% = JT& - (Monat% - 1) * 30 + 1
 IF (Jahr& + 1) MOD 4 <> 0 AND Monat% = 13 AND Tag% = 6 THEN Jahr& = Jahr& + 1: Monat% = 1: Tag% = 1
 IF Jahr& < 1 THEN Jahr& = Jahr& - 1
END SUB

SUB JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
  'Aus den Julianischen Tagen in das Julianische Datum
  b& = JD& + 1524
  c& = INT((b& - 122.1) / 365.25)
  d& = INT(365.25 * c&)
  e& = INT((b& - d&) / 30.6001)
  Tag% = b& - d& - INT(30.6001 * e&)
  IF e& < 14 THEN Monat% = e& - 1 ELSE Monat% = e& - 13
  IF Monat% > 2 THEN Jahr& = c& - 4716 ELSE Jahr& = c& - 4715
  IF Jahr& < 1 THEN Jahr& = Jahr& - 1
END SUB

SUB JultageJuldatumAera(JD&, Tag%, Monat%, Jahr&)
  CALL JultageJuldatum (JD&, Tag%, Monat%, JahrJ&)
  CALL JultageJuldatum (AeraJulian&, TagA%, MonatA%, JahrA&)
  Jahr& = JahrJ& - JahrA& + 1
  IF Monat% < MonatA% THEN Jahr& = Jahr& - 1
  IF Monat% = MonatA% AND Tag% < TagA% THEN Jahr& = Jahr& - 1
END SUB

SUB Schaltjahr(Tag%, Monat%, Jahr&)
 'Weist MonatsTage(2) den jul. bzw. greg. Wert zu
 a& = Jahr& : Datum& = 10000 * Jahr& + Monat% * 100 + Tag%
 IF a& < 0 THEN a& = a& + 1   'Kein Jahr 0 = Schalttage v.Chr. mit Rest 1
 IF a& MOD 4 = 0 THEN Monatstage%(2) = 29 ELSE Monatstage%(2) = 28
  'Geregorianische Schalttage
 IF Datum& >= DatJulGreg& THEN
   IF a& MOD 100 = 0 THEN Monatstage%(2) = 28
   IF a& MOD 400 = 0 THEN Monatstage%(2) = 29
 END IF
END SUB

SUB DatumZahl_nach_JD(Datum&, JD&, Tag%, Monat%, Jahr&)
  IF Datum& < 0 THEN f& = -1 ELSE f& = 1
  Datum& = Datum& * f&
  Jahr& = INT(Datum& / 10000)
  Monat% = INT((Datum& - Jahr& * 10000) / 100)
  Tag% = Datum& - Jahr& * 10000 - Monat% * 100
  Datum& = Datum& * f&: Jahr& = Jahr& * f&
  CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "Datum", JD&, 0)
END SUB

SUB DatumWandel(Datum$, Tag%, Monat%, Jahr&, Modus%)
  'Umwandlung eines Textfiles von Datum$ in Tag%, Monat% und Jahr&
  'Ist Datum$ leer wird das Systemdatum ausgelesen. "-" wird dann durch "." ersetzt um Jahreszahlen <0 zu ermglichen
  'Modus% = 0 mit zweistelliger Eingabe
  IF Datum$ = "" THEN Datum$ = MID$(DATE$, 4, 2) + "." + LEFT$(DATE$, 2) + "." + RIGHT$(DATE$, 4)
  b$ = Datum$ + " ": a$ = "": Tag% = 0: Monat% = 0: Jahr& = 0
  FOR t% = 1 TO LEN(b$)
    'Text "0"-"9" und "-" aussortieren und nach a$ umschreiben
    IF (MID$(b$, t%, 1) > CHR$(47) AND MID$(b$, t%, 1) < CHR$(58)) OR MID$(b$, t%, 1) = CHR$(45) THEN
      a$ = a$ + MID$(b$, t%, 1)
    ELSEIF Test% = 0 THEN
      Tag% = VAL(a$) : a$ = "": Test% = 1
    ELSEIF Test% = 1 THEN
      Monat% = VAL(a$) : a$ = "": Test% = 2
    END IF
  NEXT t%
  IF a$ = "" THEN
    Jahr& = VAL(RIGHT$(DATE$, 4))
    IF Monat% > 0 AND Monat% < 13 AND Monat% < VAL(LEFT$(DATE$, 2)) THEN Jahr& = Jahr& + 1
  ELSE
    IF VAL(a$) > -10000 AND VAL(a$) < 10000 THEN
      Jahr& = VAL(a$)
    ELSE
      IF VAL(a$) > -1 THEN Jahr& = 9999 ELSE Jahr& = -9999
    END IF
  END IF
  IF Modus% = 0 AND Jahr& < 100 AND Jahr& >= 0 AND RIGHT$(Datum$, 1) <> "#" THEN
    IF Jahr& > 49 THEN Jahr& = Jahr& + 1900 ELSE Jahr& = Jahr& + 2000
  END IF
END SUB

SUB JultageJuddatum (JD&, Tag%, Monat%, Jahr&, JL%)
 '162 sind die Tage vom 15.Nisan zum Jahresende
 CALL JultageJuldatum (JD&, t%, m%, Jahr&)
 JJahr& = Jahr& : Jahr& = Jahr& + 3760
 CALL JudSchaltjahrAbs (Jahr&, JDN&, JL%)
 Tag% = JD& - (JDN& + 162 - JL%)
 Monat% = 1
 WHILE Tag% > Judtage%(Monat%)
   Tag% = Tag% - Judtage%(Monat%)
   Monat% = Monat% + 1
   IF Monat% > 13 THEN Monat% = 1 : Jahr& = Jahr& + 1 : CALL JudSchaltjahrAbs (Jahr&, JDN&, JL%)
 WEND
 IF JJahr& < 1 THEN Jahr& = Jahr& + 1  'Das Jahr 0 wegrechnen
END SUB

SUB JudSchaltjahrAbs (JudJahr&, JD1&, JL%)
 'Initialisiert die Monatslngen
 'bergibt den 15. Nissan als JD1& und die Jahreslnge als JL%
 Jahr& = JudJahr& -3760
 CALL Gauss (Jahr&, JD1&)
 CALL Gauss (Jahr& -1, JD2&)
 JL% = JD1& - JD2&
 IF JL% = 88 THEN JL% = 355 'Sonderfall im Jahr 1
 IF JL% = 354 THEN Judtage%(2) = 29 : Judtage%(3) = 30 : Judtage%(6) = 29 : Judtage%(7) = 0
 IF JL% = 355 THEN Judtage%(2) = 30 : Judtage%(3) = 30 : Judtage%(6) = 29 : Judtage%(7) = 0
 IF JL% = 353 THEN Judtage%(2) = 29 : Judtage%(3) = 29 : Judtage%(6) = 29 : Judtage%(7) = 0
 IF JL% = 384 THEN Judtage%(2) = 29 : Judtage%(3) = 30 : Judtage%(6) = 30 : Judtage%(7) = 29
 IF JL% = 385 THEN Judtage%(2) = 30 : Judtage%(3) = 30 : Judtage%(6) = 30 : Judtage%(7) = 29
 IF JL% = 383 THEN Judtage%(2) = 29 : Judtage%(3) = 29 : Judtage%(6) = 30 : Judtage%(7) = 29
END SUB

SUB JultageAethopisch (JD&, Tag%, Monat%, Jahr&)
 AeraAethopisch& = 1724220
 JT& = JD& - AeraAethopisch& + 364
 Jahr& = INT(JT& / 365.25)
 JT& = JT& - Jahr& * 365 - INT(Jahr& / 4)
 Monat% = INT (JT& / 30) + 1
 Tag% = JT& - (Monat% - 1) * 30 + 1
 IF (Jahr& + 1) MOD 4 <> 0 AND Monat% = 13 AND Tag% = 6 THEN Jahr& = Jahr& + 1: Monat% = 1: Tag% = 1
 IF Jahr& < 1 THEN Jahr& = Jahr& - 1
END SUB

SUB JultageScaligerdatum (JD&, Jahr&, Restklasse$)
 'Aus den Julianischen Tagen das Julianische Datum
 Jahr& = INT(JD& / 365.25) + 1
 SZ% = Jahr& MOD 28
 GZ% = Jahr& MOD 19
 RZ% = Jahr& MOD 15
 IF Jahr& <> 0 AND Jahr& MOD 7980 = 0 THEN SZ% = 28 : GZ% = 19 : RZ% = 15
 Restklasse$ = "<" + RIGHT$(USING$(".##", SZ% / 100), 2) + RIGHT$(USING$(".##", GZ% / 100), 3) + RIGHT$(USING$(".##_>", RZ% / 100), 4)
END SUB

SUB JultageTzolkinDatum((JD&, T20%, T13%)
  IF (MayaAnzeige% AND 28) THEN a& = AeraAztek260& ELSE a& = AeraTzolkin&
  T13% = (JD& - a& ) MOD 13
  IF T13% < 0 THEN T13% = T13% + 13
  T13% = T13% + 1
  T20% = (JD& - a&) MOD 20
  IF T20% < 0 THEN T20% = T20% + 20
END SUB

SUB JultageHaabDatum(JD&, Tag%, Monat%)
  IF (MayaAnzeige% AND 28) THEN Tag% = (JD& - AeraAztek365&) MOD 365 ELSE Tag% = (JD& - AeraHaab&) MOD 365
  IF Tag% < 0 THEN Tag% = Tag% + 365
  Monat% = INT(Tag% / 20)
  Tag% = Tag% - Monat% * 20
  IF Tag% > 20 THEN Monat% = Monat% + 1: Tag% = Tag% - 20 'Letzer Monat mit 5 Tagen
END SUB

SUB JultageLangeZahlDatum(JD&, Baktun%, Uinal%, Tun%, Katun% , Kin%)
 n& = JD& - AeraMaya&
 Baktun% = INT(n& / 144000)  : n& = n& - Baktun% * 144000
 Uinal%  = INT(n& / 7200)    : n& = n& - Uinal% * 7200
 Tun%    = INT(n& / 360)     : n& = n& - Tun% * 360
 Katun%  = INT(n& / 20)
 Kin% = n& - Katun% * 20
END SUB

SUB MayadatumJultage(Mayadat$, JD&)
 Baktun% = ABS(VAL(MID$(Mayadat$, 1, 2)))
 Uinal%  = ABS(VAL(MID$(Mayadat$, 3, 2)))
 Tun%    = ABS(VAL(MID$(Mayadat$, 5, 2)))
 Katun%  = ABS(VAL(MID$(Mayadat$, 7, 2)))
 Kin%    = ABS(VAL(MID$(Mayadat$, 9, 2)))
 JD& = Baktun% * 144000 + Uinal% * 7200 + Tun% * 360 + Katun% * 20 + Kin% + AeraMaya&
END SUB

SUB MayaTagesgott(JD&, TGott$)
  CALL JultageTzolkinDatum(JD&, T20%, T13%)
  IF MayaAnzeige% = 1 THEN CALL LeseMonatsname("TZOLK13.MON", T13%, TGott$, 0)
  IF MayaAnzeige% = 2 THEN CALL LeseMonatsname("TZOL13DT.MON", T13%, TGott$, 0)
END SUB

SUB JultageTzolkin(JD&, Tzolkin$)
  CALL JultageTzolkinDatum(JD&, T20%, T13%)
  IF MayaAnzeige% < 2 THEN
    CALL LeseMonatsname("TZOLKIN.MON", T20% + 1, Tzolkin$, 0)
  ELSEIF MayaAnzeige% = 2 THEN
    CALL LeseMonatsname("TZOLKIDT.MON", T20% + 1, Tzolkin$, 0)
  ELSEIF (MayaAnzeige% AND 20) THEN
    CALL LeseMonatsname("TONAL.MON", T20% + 1, Tzolkin$, 0)
  ELSEIF MayaAnzeige% = 8 THEN
    CALL LeseMonatsname("TONALDT.MON", T20% + 1, Tzolkin$, 0)
  END IF
  Tzolkin$ = USING$("##", T13%) + " " + Tzolkin$
END SUB

SUB JultageHaab(JD&, Haab$)
  'Der Haab und der Xihuitl gibt es nur im Original
  CALL JultageHaabDatum(JD&, Tag%, Monat%)
  IF MayaAnzeige% < 4 THEN
    CALL LeseMonatsname("HAAB.MON", Monat% + 1, Haab$, 0)
  ELSE
    CALL LeseMonatsname("XIHUITL.MON", Monat% + 1, Haab$, 0)
  END IF
  Haab$ = USING$("##", Tag%) + " " + Haab$
END SUB

SUB JulTageLangeZahl(JD&, LangeZahl$, LangeZahlL$)
  CALL JultageLangeZahlDatum(JD&, Baktun%, Uinal%, Tun%, Katun% , Kin%)
  LangeZahl$ = RIGHT$("00" + LTRIM$(STR$(Baktun%)), 2)
  LangeZahl$ = LangeZahl$ + RIGHT$("00" + LTRIM$(STR$(Uinal%)), 2)
  LangeZahl$ = LangeZahl$ + RIGHT$("00" + LTRIM$(STR$(Tun%)), 2)
  LangeZahl$ = LangeZahl$ + RIGHT$("00" + LTRIM$(STR$(Katun%)), 2)
  LangeZahl$ = LangeZahl$ + RIGHT$("00" + LTRIM$(STR$(Kin%)), 2)
  LangeZahlL$ = LTRIM$(STR$(Baktun%)) + "." + LTRIM$(STR$(Uinal%)) + "." + LTRIM$(STR$(Tun%)) + "." + LTRIM$(STR$(Katun%)) + "." + LTRIM$(STR$(Kin%))
END SUB

SUB Jahrestraeger(JD&, JTraeger$)
 'JDT& = Jahrsanfang
  IF (MayaAnzeige% AND 28) THEN JDT& = INT((JD& - AeraAztek365&) / 365) * 365 + AeraAztek365& ELSE JDT& = INT((JD& - AeraHaab&) / 365) * 365 + AeraHaab&
  CALL JultageTzolkin(JDT&, JTraeger$)
END SUB

SUB KatunZaehlung(JD&, TunName$)
  JDT& = INT((JD& - AeraMaya&) / 7200) * 7200 + AeraMaya& 'Letzter Tun
  CALL JultageTzolkin(JDT&, TunName$)
END SUB

SUB MayaAktuellerTag(JD&)
  Merke% = MayaAnzeige%
  MayaAnzeige% = 0

  CALL JulTageLangeZahl(JD&, "", LangeZahlL$)
  CALL JultageTzolkin(JD&, Tzolkin$)
  CALL JultageHaab(JD&, Haab$)
  CALL KatunZaehlung(JD&, TunName$)
  MayaAnzeige% = 1: CALL MayaTagesgott(JD&, TGott$)
  MayaAnzeige% = 2:
  CALL MayaTagesgott(JD&, TGottDt$)
  CALL JultageTzolkin(JD&, TzolkinDt$)

  MayaAnzeige% = 4
  CALL JultageTzolkin(JD&, Tonal$)
  CALL Jahrestraeger(JD&, JTraeger$)
  MayaAnzeige% = 8: CALL JultageTzolkin(JD&, TonalDt$)
  CALL JultageHaab(JD&, Xihuitl$)
  CALL Jahrestraeger(JD&, JTraegerDt$)

  CALL TextAufbereitung("Julianischer Tag.:" + STR$(JD&) + "<br>", 76, x%, y%, 0)

  CALL TextAufbereitung("Mayas", 76, x%, y%, 1)
  CALL TextAufbereitung("Lange Zhlung....: " + LangeZahlL$, 76, x%, y%, 1)
  CALL TextAufbereitung("Tzolkin..........: " + Tzolkin$ + " (" + RIGHT$(TzolkinDt$, LEN(TzolkinDt$) - 3) + ")", 76, x%, y%, 1)
  CALL TextAufbereitung("Haab.............: " + Haab$ + "<br>", 76, x%, y%, 1)

  CALL TextAufbereitung("Tzolkin Ableitungen", 76, x%, y%, 1)
  CALL TextAufbereitung("Tagesgott........: " + TGott$ + " (" + TGottDt$ +")", 76, x%, y%, 1)
  CALL TextAufbereitung("Katunzhlung.....: " + TunName$ + "<br>", 76, x%, y%, 1)

  CALL TextAufbereitung("Azteken", 76, x%, y%, 1)
  CALL TextAufbereitung("Tonalamatl.......: " + Tonal$ + " (" + RIGHT$(TonalDt$, LEN(TonalDt$) - 3) + ")", 76, x%, y%, 1)
  CALL TextAufbereitung("Trger des Jahres: " + JTraeger$ + " (" + RIGHT$(JTraegerDt$, LEN(JTraegerDt$) - 3) + ")", 76, x%, y%, 1)
  CALL TextAufbereitung("Xihuitl..........: " + Xihuitl$, 76, x%, y%, 1)
  CALL InfoTextAusgabe(" Aktuelles Datum ", x% , y%, 0)
  MayaAnzeige% = Merke%
END SUB

SUB MayadatumEingabe (Text$, Datum$, JD&, Test%)
 Test% = 0
 DO
   CALL Texteingabe_t (Datum$, sz$, Text$, 14)
   IF sz$ = CHR$(27) THEN EXIT SUB
   CALL MayadatumWandel (Datum$, Mayadat$, Test%)
 LOOP UNTIL Test% = 0 OR sz$ = CHR$(27)
 IF sz$ <> CHR$(27) THEN CALL MayadatumJultage (Mayadat$, JD&)
 Test% = 1
END SUB

SUB MayadatumWandel (Datum$, Mayadat$, Test%)
 DIM m%(5) : z% = 1 : Test% = 0 : Mayadat$ = ""
 FOR t% = 1 TO LEN(Datum$)
   'Text "0"-"9" aussortieren und nach a$ umschreiben
   IF (MID$(Datum$, t%, 1) > CHR$(47) AND MID$(Datum$, t%, 1) < CHR$(58)) AND LEN(a$) < 2 THEN
     a$ = a$ + MID$(Datum$, t%, 1)
   ELSE
     m%(z%) = VAL(a$)
     IF MID$(Datum$, t%, 1) > CHR$(47) AND MID$(Datum$, t%, 1) < CHR$(58) THEN a$ = MID$(Datum$, t%, 1) ELSE a$ = ""
     IF m%(z%) > 19 OR m%(4) > 17 THEN CALL Fehlermeldung ("An der" + STR$(z%) + ". Zahl ist die Eingabe zu gro") : Test% = 1 : EXIT SUB
     z% = z% +1 : IF z% > 5 THEN CALL Fehlermeldung ("94") : Test% = 2 : EXIT SUB
   END IF
 NEXT t%
 IF z% < 6 THEN m%(z%) = VAL(a$) ELSE CALL Fehlermeldung ("94") : Test% = 3 : EXIT SUB
 IF m%(z%) > 19 OR m%(4) > 17 THEN CALL Fehlermeldung ("An der" + STR$(z%) + ". Zahl ist die Eingabe zu gro") : Test% = 4 : EXIT SUB
 FOR t% = 1 TO 5
   Mayadat$ = Mayadat$ + RIGHT$("00" + LTRIM$(STR$(m%(t%))), 2)
 NEXT t%
 CALL MayadatumJultage (Mayadat$, JD&)
 IF JD& > 3218554 THEN CALL Fehlermeldung ("95") : Test% = 5
 IF JD& < 584283 THEN CALL Fehlermeldung ("96") : Test% = 6
 ERASE m%
END SUB

SUB AztekenEpoche
 diainputsize% = 7 'sichbare Eingabelnge
 Tzolkin$ = LTRIM$(STR$(AeraAztek260&)): mat& = AeraAztek260&
 Haab$ = LTRIM$(STR$(AeraAztek365&)): mah& = AeraAztek365&
 CALL diawin (2, Spalte%, 9, 29, " Aztekenepoche ", %ON)
 CALL diainp (2, 3, "Tonamamatl..:", 2, 18, 7, Tzolkin$)
 CALL diainp (4, 3, "Xihuitl.....:", 4, 18, 7, Haab$)
 CALL diapush (6, 14, "bernehmen")
 CALL diapush (6, 2, "Abbruch")
 CALL diaset (1)
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 4 THEN
     AeraAztek260& = mat&: AeraAztek365& = mah&
     CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 3 AND l% = %ENTER THEN
       EinMaya& = VAL(Tzolkin$)
       IF Tzolkin$ = "" THEN CALL Fehlermeldung ("100"): Test% = 1
       IF EinMaya& < 1 THEN CALL Fehlermeldung ("101"): Test% = 1
       IF EinMaya& > 3218554 THEN CALL Fehlermeldung ("102"): Test% = 1
       IF Test% = 0 THEN
         AeraAztek260& = EinMaya&
         EinMaya& = VAL(Haab$)
         IF Haab$ = "" THEN CALL Fehlermeldung ("103"): Test% = 2
         IF EinMaya& < 1 THEN CALL Fehlermeldung ("104"): Test% = 2
         IF EinMaya& > 3218554 THEN CALL Fehlermeldung ("105"): Test% = 2
         IF Test% = 0 THEN AeraAztek365&  = EinMaya&: EXIT LOOP
       END IF
     END IF
   IF Test% <> 0 THEN CALL diaset (Test%)
 LOOP
 CALL diaclose : mouseon
END SUB

SUB MayaEpoche
 diainputsize% = 7 'sichbare Eingabelnge
 Tzolkin$ = LTRIM$(STR$(AeraTzolkin&)): mat& = AeraTzolkin&
 Haab$ = LTRIM$(STR$(AeraHaab&)): mah& = AeraHaab&
 Maya$ = LTRIM$(STR$(AeraMaya&)): mam& = AeraMaya&
 CALL diawin (2, Spalte%, 13, 29, " Mayaepoche (JD) ", %ON)
 CALL diainp (2, 3, "Tzolkin.....:", 2, 18, 7, Tzolkin$)
 CALL diainp (4, 3, "Haab........:", 4, 18, 7, Haab$)
 CALL diainp (6, 3, "Lange Zhlung:", 6, 18, 7, Maya$)
 CALL diapush (10, 14, "bernehmen")
 CALL diapush (10, 2, "Abbruch")
 CALL diapush (8, 6, "4 Ahau 8 Cumku")
 CALL diaset (1)
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 5 THEN
     AeraMaya& = mam&: AeraTzolkin& = mat&: AeraHaab& = mah&
     CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 4 AND l% = %ENTER THEN
     EinMaya& = VAL(Maya$)
     IF Maya$ = "" THEN CALL Fehlermeldung ("97"): Test% = 3
     IF EinMaya& < 1 THEN CALL Fehlermeldung ("98"): Test% = 3
     IF EinMaya& > 3218554 THEN CALL Fehlermeldung ("99"): Test% = 3
     IF Test% = 0 THEN
       AeraMaya& = EinMaya&
       EinMaya& = VAL(Tzolkin$)
       IF Tzolkin$ = "" THEN CALL Fehlermeldung ("100"): Test% = 1
       IF EinMaya& < 1 THEN CALL Fehlermeldung ("101"): Test% = 1
       IF EinMaya& > 3218554 THEN CALL Fehlermeldung ("102"): Test% = 1
       IF Test% = 0 THEN
         AeraTzolkin& = EinMaya&
         EinMaya& = VAL(Haab$)
         IF Haab$ = "" THEN CALL Fehlermeldung ("103"): Test% = 2
         IF EinMaya& < 1 THEN CALL Fehlermeldung ("104"): Test% = 2
         IF EinMaya& > 3218554 THEN CALL Fehlermeldung ("105"): Test% = 2
         IF Test% = 0 THEN AeraHaab& = EinMaya&: EXIT LOOP
       END IF
     END IF
   ELSEIF d% = 6 THEN
     Haab$ = LTRIM$(STR$((VAL(Maya$) + 17) MOD 365))
     Tzolkin$ = LTRIM$(STR$((VAL(Maya$) + 101) MOD 260))
   END IF
   IF Test% <> 0 THEN CALL diaset (Test%)
 LOOP
 CALL diaclose : mouseon
END SUB

SUB JultageMoham (JD&, MTag%, MMonat%, MJahr&)
 IF MohamDat% < 3 THEN Start& = 1948439 ELSE Start& = 1948438
 IF JD& = Start& THEN MTag% = 29 : MMonat% = 12 : MJahr& = 0 : EXIT SUB
 IF JD& = Start& -1 THEN MTag% = 28 : MMonat% = 12 : MJahr& = 0 : EXIT SUB
 a& = JD& - Start&
 IF a& < 1 THEN a& = a& +1
 Zyklus& = INT(a& / 10631)
 MJahr& = Zyklus& * 30 +1
 MTag% = a& - Zyklus& * 10631
 CALL MohamSchaltjahr (MJahr&)
 WHILE MTag% > 325 + Mohamtage%(12)
   MTag% = MTag% -325 - Mohamtage%(12)
   MJahr& = MJahr& +1
   CALL MohamSchaltjahr (MJahr&)
 WEND
 MMonat% = 1
 WHILE MTag% > Mohamtage%(MMonat%)
   MTag% = MTag% - Mohamtage%(MMonat%)
   MMonat% = MMonat% +1
 WEND
END SUB

SUB MohamSchaltjahr (MJahr&)
 IF MohamDat% = 2 OR MohamDat% = 4 THEN sj% = 15 ELSE sj% = 16
 Mohamtage%(12) = 29
 s% = ABS(MJahr& MOD 30)
 IF s% = 2 OR s% = 5 OR s% = 7 OR s% = 10 OR s% = 13 OR s% = sj% OR s% = 18 OR s% = 21 OR s% = 24 OR s% = 26 OR s% = 29 THEN Mohamtage%(12) = 30
END SUB

SUB RoemischerTag (JD&, Tagesbuchstabe$, MB%, RoemDatum$, Kurzform$)
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL Schaltjahr(Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JD1&, 0)

 MB% = (JD& - 6) MOD 8 'Tagesbuchstabe des Jahres farbig

 'Tagesbuchstabe und Tagescharakter
 TagImJahr% = JD& - JD1& + 1
 IF Monatstage%(2) = 29 THEN Pfadname$ = DN_ROEMTAGS$ ELSE Pfadname$ = DN_ROEMTAGN$
 OPEN Pfadname$ FOR INPUT AS #1
 FOR t% = 1 TO TagImJahr%
   INPUT #1, Tagesbuchstabe$, Tagescharakter$
 NEXT t%
 CLOSE #1
 IF LEN(Tagescharakter$) = 1 THEN Tagescharakter$ = Tagescharakter$ + " "
 'Tageszhlung
 SELECT CASE Monat%
   CASE 1,8,12: Pfadname$ = DN_ROMTAG_A$
   CASE 2
     IF Monatstage%(2) = 28 THEN Pfadname$ = DN_ROMTAG_B$
     IF Monatstage%(2) = 29 THEN Pfadname$ = DN_ROMTAG_C$
   CASE 3,5,7,10: Pfadname$ = DN_ROMTAG_D$
   CASE 4,6,9,11: Pfadname$ = DN_ROMTAG_E$
 END SELECT
 OPEN Pfadname$ FOR INPUT AS #1
 FOR t% = 1 TO Tag%
   INPUT #1, Kurzform$, Langform$
 NEXT t%
 CLOSE #1

 'Tagesnummer festlegen
 IF Monat% = 3 OR Monat% = 5 OR Monat% = 7 OR Monat% = 10 THEN
   Kalenden% = 1: Nonen% = 7: Iden% = 15
 ELSE
   Kalenden% = 1: Nonen% = 5: Iden% = 13
 END IF

 'Monatsname
 IF Tag% > Iden% THEN LMonat% = Monat% + 1 ELSE LMonat% = Monat%
 IF LMonat% = 13 THEN LMonat% = 1

 RoemDatum$ = Tagescharakter$ + " " + Langform$ + " "
 IF Tag% = Kalenden% OR Tag% = Nonen% OR Tag% = Iden%  THEN
   CALL LeseMonatsname("ROEMABL.MON", LMonat%, RoemnameAbl$, 0)
   RoemDatum$ = RoemDatum$ + RoemnameAbl$
 ELSE
   CALL LeseMonatsname("ROEMAKK.MON", LMonat%, RoemnameAkk$, 0)
   RoemDatum$ = RoemDatum$ + RoemnameAkk$
 END IF
END SUB

SUB JultageBabylonisch(JD&, BabTag%, BabMonat%, BabJahr&)
 IF JD& < 182 THEN EXIT SUB 'Notausgang
  Babylon# = 11 / 24 '+ .5  '11 Stunden da Neulicht erst am bernchsten Tag sichtbar.

  'Jahresanfang
  t1% = 0
  DO
    CALL Jahreszeit(JD& + t1%, JDE#, 0, 3)
    CALL JulTageZeit (JDE# + 3 / 24, s%, m%, h%, Fruehling&)
    t% = 0
    DO
      CALL Neumond(Fruehling& + t%, JDE#) 'vor Frhling
      CALL JulTageZeit (JDE# + Babylon#, s%, m%, h%, JD_nm&)
      t% = t% - 29
    LOOP WHILE JD_nm& => Fruehling&

    IF (BabylMod% AND 2 ^ 1) = 0 THEN 'nach Frhling
      CALL Neumond(Fruehling& + t% + 58, JDE#)
      CALL JulTageZeit (JDE# + Babylon#, s%, m%, h%, JD_nm&)
    END IF

    t1% = t1% - 354
  LOOP WHILE JD& - JD_nm& <= 0


  BabJahr& = INT((Fruehling& - AeraBabylonisch&) / 365.243) + 1

  'Monat und Tag abzhlen
  Start& = JD_nm&
  BabMonat% = 0
  WHILE Start& < JD&
    Start& = Start& + 28
    BabMonat% = BabMonat% + 1
    BabTag% = JD& - JD_nm&
    CALL Neumond(Start&, JDE#)
    CALL JulTageZeit (JDE# + Babylon#, s%, m%, h%, JD_nm&)
    Start& = JD_nm&
  WEND
END SUB

SUB Neumond(JD&, JDE#)
 'Fr den Chinesischen Kalender
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
 IF Jahr& < 0 THEN Jahr& = Jahr& + 1 'das Jahr Null hinzurechnen
 t% = 0
 WHILE JD_nm& < JD&
   k# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685)
   CALL Mondphase_Neumondkorrekturen(k#, JDE#)
   CALL Mondphase_Zusatzkorrekturen(k#, JDE#)
   CALL JulTageZeit (JDE#, s%, m%, h%, JD_nm&)
   t% = t% + 1
 WEND
END SUB

SUB JultageChinesisch(JD&, ChTag%, ChMonat%, ZyklusJahr%, Zyklus%, TierJahr%, ErdeJahr%, TierTag%, ErdeTag%)
 IF JD& < 40 THEN EXIT SUB 'Notausgang
 'NMond&(13, 1) ist SHARED
 'Peking# = + 8 Std. Zeitzone + 1/2 Tag von JDE# nach JD&
 'Die Zhlung beginnt am 8.3 2637 v.Chr. im 61. Jahr des Kaisers Hoang-ti
 AeraChinesisch& = 758326
 AeraChinTag& = 758330
 Peking# = 8 / 24 + .5
 IF JD& < 2425653 THEN Peking# = Peking# - .009722222 'Vor 1929 Ortszeit von Peking (-14 Min.)

 'Ein vllig neues Datum
 IF JD& < NMond&(0, 0) OR JD& >= NMond&(0, 1) THEN

   CALL Jahreszeit(JD&, JDE#, 0, 12)' Winteranfang
   WinteranfangN& = INT(JDE# + Peking#)
   IF JD& <= WinteranfangN& THEN
     CALL Jahreszeit(JD& - 365, JDE#, 0, 12)' Winteranfang Vorjahr
     WinteranfangV& = INT(JDE# + Peking#)
   ELSE
     WinteranfangV& = WinteranfangN&
     CALL Jahreszeit(JD& + 365, JDE#, 0, 12)' Winteranfang folgendes Jahr
     WinteranfangN& = INT(JDE# + Peking#)
   END IF

   NMond&(1, 0) = 0 'Zum Schaltjahrtest
   CALL Neumond(WinteranfangN&, JDE#)
   NMond&(13, 0) = INT(JDE# + Peking#)
   t% = 0
   WHILE NMond&(13, 0) > WinteranfangN& 'Suchen immer wegen ungenauer Datumzuordung der Mondphase
     t% = t% + 15
     CALL Neumond(WinteranfangN& - t%, JDE#)
     NMond&(13, 0) = INT(JDE# + Peking#)
   WEND
   NMond&(0, 1) = NMond&(13, 0) 'Endmond zum Testen

   'Die Neumonde zwischen den Winteranfngen ermitteln
   MNr% = 12
   FOR t& = NMond&(13, 0) TO WinteranfangV& STEP -3
     CALL Neumond(t&, JDE#)
     mxx& = INT(JDE# + Peking#)
     IF mxx& < NMond&(MNr% + 1, 0) THEN
       NMond&(MNr%, 0) = mxx&
       t& = mxx&
       MNr% = MNr% - 1
     END IF
   NEXT t&
   NMond&(0, 0) = mxx&  'Startmond zum Testen


   IF WinteranfangV& = NMond&(1, 0) THEN MNr% = 11%: SMTest% = 1 ELSE MNr% = 12%
   IF NMond&(1, 0) <> 0 THEN 'Schaltjahr
     FOR t% = 1 TO 12
       NMond&(t%, 1) = 0
       IF SMTest% = 0 THEN 'Liegen die Neumonde in einer durch 30 teilbaren Sonnenposition?
         CALL Sonnenbahn (NMond&(t%, 0) - Peking#, VLaenge#, B#, E#): VLaenge# = Kreis(VLaenge#)
         CALL Sonnenbahn (NMond&(t% + 1, 0) - Peking#, NLaenge#, B#, E#): NLaenge# = Kreis(NLaenge#)
         IF INT(NLaenge# / 30) = INT (VLaenge# / 30) THEN MNr% = MNr% - 1: SMTest% = 1: NMond&(t%, 1) = 100
       END IF
       NMond&(t%, 1) = NMond&(t%, 1) + MNr%
       IF NMond&(t%, 1) = 100 THEN NMond&(t%, 1) = 112 'Sonderfall 12. Monat = Schaltmonat
       MNr% = MNr% + 1: IF MNr% = 13 THEN MNr% = 1
     NEXT t%
     NMond&(13, 1) = 11
   ELSE 'Kein Schaltjahr
     FOR t% = 2 TO 13
       NMond&(t%, 1) = MNr%: MNr% = MNr% + 1: IF MNr% = 13 THEN MNr% = 1 'Monatsnummern
     NEXT t%
   END IF
 END IF

 t% = 13
 WHILE JD& < NMond&(t%, 0) AND t% > 0
   t% = t% - 1
 WEND
 IF JD& < NMond&(t%, 0) OR NMond&(t%, 0) = 0 THEN  'Datum zwischen Winteranfang und folgendem Neumond
   ChMonat% = 11
   CALL Neumond(WinteranfangV& - 30, JDE#)
   IF JD& - INT(JDE# + Peking#) + 1 > 30 THEN CALL Neumond(WinteranfangV& - 15, JDE#) 'zu weit gesprungen
   ChTag% = JD& - INT(JDE# + Peking#) + 1
 ELSE
   ChMonat% = NMond&(t%, 1)
   ChTag% = JD& - NMond&(t%, 0) + 1
 END IF

 'Das Jahr berechnen
 IF ChMonat% > 99 THEN n% = 99 ELSE n% = 0 'eventuellen Schaltmonat, der mit + 100 gekennzeichnet istm ausgleichen
 m% = (6 - ChMonat% + n%) * 29 'ungefhre Tage zum 6. Monat des Jahres damit der bergang vom 29. (30.) 12. zum 1.1. stimmt
 ChJahr& = INT((JD& - AeraChinesisch& + m%) / 365.2421875)

 ErdeJahr% = (ChJahr& + 1) MOD 10
 IF ErdeJahr% < 0 THEN ErdeJahr% = ABS(ErdeJahr% + 10)
 IF ErdeJahr% = 0 THEN ErdeJahr% = 10

 TierJahr% = (ChJahr& + 1) MOD 12
 IF TierJahr% < 0 THEN TierJahr% = ABS(TierJahr% + 12)
 IF TierJahr% = 0 THEN TierJahr% = 12

 Zyklus% = INT (ChJahr& / 60)
 IF Zyklus% > -1 THEN Zyklus% = Zyklus% + 1

 ZyklusJahr% = ChJahr& - Zyklus% * 60
 IF ZyklusJahr% < 0 THEN ZyklusJahr% = ZyklusJahr% + 61 ELSE  ZyklusJahr% = ZyklusJahr% + 1

 ErdeTag% = (JD& - AeraChinTag&) MOD 10
 IF ErdeTag% < 0 THEN ErdeTag% = ABS(ErdeTag% + 10)
 IF ErdeTag% = 0 THEN ErdeTag% = 10

 TierTag% = (JD& - AeraChinTag& + 4) MOD 12
 IF TierTag% < 0 THEN TierTag% = ABS(TierTag% + 12)
 IF TierTag% = 0 THEN TierTag% = 12
END SUB

SUB ChinesischeJahreszeit(JD&)
  CALL TagesSekunden (TagSek&)
  JDE# = JD& - .5 + TagSek& / 86400
  CALL Sonnenbahn (JDE#, Laenge#, 0, 0): Laenge# = Kreis(Laenge#)
  OPEN DN_CHJAHRZE$ FOR INPUT AS #1
  WHILE NOT EOF(1) AND Laenge# > Grad#
    b$ = a$
    INPUT #1, Grad#, a$
  WEND
  CLOSE #1
  CALL TextAufbereitung(b$, 76, x%, y%, 0)
  CALL InfoTextAusgabe(" Chinesische Jahreszeit ", x% , y%, 0)
END SUB

SUB ChinesischJultage(ChTag%, ChMonatE%, ZyklusJahr%, Zyklus%, JD&, Test%, a$)
  Test% = 0
  AeraChinesisch& = 758326
  Jahr& = (Zyklus% - 1) * 60 + ZyklusJahr% -2
  JD& = INT (Jahr& * 365.2421875) + AeraChinesisch& + 308
  IF Zyklus% < 0 THEN Zyklus% = Zyklus% - 1: JD& = JD& + 21924
  WHILE ChMonatE% <> ChMonatT% OR ZyklusT% < Zyklus% OR ZyklusJahrT% <> ZyklusJahr%
    JD& = JD& + 26
    CALL JultageChinesisch(JD&, ChTagT%, ChMonatT%, ZyklusJahrT%, ZyklusT%, TierJahr%, ErdeJahr%, TierTag%, ErdeTag%)
    d% = d% + 1: IF d% > 25 THEN a$ = "Ungltiger Schaltmonat": Test% = 7: EXIT SUB
  WEND
  JD& = JD& - ChTagT% + ChTag%
END SUB

SUB ChinDatumEingabe (Text$, Datum$, JD&, Test%)
 Test% = 0
 DO
   CALL Texteingabe_t (Datum$, sz$, Text$, 13)
   IF sz$ = CHR$(27) THEN EXIT SUB
   CALL ChinDatumWandel (Datum$, ChTag%, ChMonat%, Zyklusjahr%, Zyklus%)
   CALL ChinDatumTest (ChTag%, ChMonat%, Zyklusjahr%, Zyklus%, Test%, JDC&)
 LOOP UNTIL Test% = 0 OR sz$ = CHR$(27)
 IF sz$ <> CHR$(27) THEN JD& = JDC& 'CALL ChinesischJultage(ChTag%, ChMonat%, Zyklusjahr%, Zyklus%, JD&)
 Test% = 1
END SUB

SUB ChinDatumWandel (Datum$, ChTag%, ChMonat%, Zyklusjahr%, Zyklus%)
 'Umwandlung eines Textfiles von Datum$ in ChTag%, ChMonat%, Zyklus% und ZyklusJahr%
 b$ = Datum$ + " " : a$ = "" : ChTag% = 0 : ChMonat% = 0 : ZyklusJahr% = 0 : Zyklus% = 0
 FOR t% = 1 TO LEN(b$)
   'Text "0"-"9" und "-" aussortieren und nach a$ umschreiben
   IF (MID$(b$, t%, 1) > CHR$(47) AND MID$(b$, t%, 1) < CHR$(58)) OR MID$(b$, t%, 1) = CHR$(45) THEN
     a$ = a$ + MID$(b$, t%, 1)
   ELSE
     n% = n% + 1
     IF n% = 1 THEN ChTag% = VAL(a$) : a$ = ""
     IF n% = 2 THEN ChMonat% = VAL(a$) : a$ = "": IF MID$(b$, t%, 1) = "*" THEN ChMonat% = ChMonat% + 100: t% = t% + 1'Schaltmonat
     IF n% = 3 THEN Zyklusjahr% = VAL(a$) : a$ = ""
     IF n% = 4 THEN Zyklus% = VAL(a$) : a$ = ""
   END IF
 NEXT t%
END SUB

SUB ChinDatumTest (ChTag%, ChMonat%, Zyklusjahr%, Zyklus%, Test%, JDC&)
 'Testet Tag%, Monat% und Jahr& auf sinnvolle Daten
 'Ist Test% <> 0 Datum war falsch
 Test% = 0 : a$ = ""
 IF ChTag% < 1 OR ChTag% > 30 THEN
   a$ = "106" : Test% = 4
 ELSE
   IF (ChMonat% < 1 OR ChMonat% > 12) AND (ChMonat% < 101 OR ChMonat% > 112) THEN
     a$ = "107" : Test% = 3
   ELSE
     IF Zyklusjahr% < 1 OR Zyklusjahr% > 60 THEN
       a$ = "108": Test% = 2
     ELSE
       IF Zyklus% < -35 OR Zyklus% = 0 OR Zyklus% >99 THEN
         a$ = "109": Test% = 1
       END IF
     END IF
   END IF
 END IF
 IF Test% = 0 THEN
   CALL ChinesischJultage(ChTag%, ChMonat%, Zyklusjahr%, Zyklus%, JDC&, Test%, a$)
   IF JDC& < 40 THEN a$ = "110" : Test% = 5
   IF JDC& > 3218554 THEN a$ = "111" : Test% = 6
 END IF
 IF Test% <> 0 THEN CALL Fehlermeldung (a$)
END SUB

SUB JultageWelt(JD&, Tag%, Monat%, Jahr&, wt%)
  'wt% = -1 = Silvester (Welttag), wt% = -2 = Schalttag
  'Jahresbeginn immer Sonntags
  CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
  'CALL GregdatumJultage (1, 1, Jahr&, JDS&)
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
  CALL Schaltjahr (Tag%, Monat%, Jahr&)
  Tag% = JD& - JDS& + 1
  IF Monatstage%(2) = 29 THEN
    IF Tag% = 183 THEN Monat% = 6: Tag% = 31: wt% = -2: EXIT SUB 'Schalttag
    IF Tag% = 366 THEN Monat% = 12: Tag% = 31: wt% = -1: EXIT SUB 'Welttag
    IF Tag% > 183 THEN wt% = (Tag% - 2) MOD 7 ELSE wt% = (Tag% - 1) MOD 7 'Tagesname im Schaltjahr
  ELSE
    IF Tag% = 365 THEN Monat% = 12: Tag% = 31: wt% = -1: EXIT SUB 'Welttag
    wt% = (Tag% - 1) MOD 7
  END IF
  Monat% = 1: s% = 31
  WHILE Tag% > s%
    Tag% = Tag% - s%
    Monat% = Monat% + 1
    IF Monat% MOD 3 = 1 OR Monat% = 12 OR (Monat% = 6 AND Monatstage%(2) = 29) THEN s% = 31 ELSE s% = 30
  WEND
END SUB

SUB JulianMond(JD&, Tag%, Monat%, Jahr&, GZahl%, Epakte%, EpakteMrz%, Modus%, MName$)
  'Modus% and 1 = Schalttag
  '           2 = Schaltmonat
  '           4 = saltus lune
  '           8 = Ostergrenze
  '          16 = Monat nach Schalttag beginnt einen Tag spter
  CALL JultageJuldatum (JD&, sTag%, sMonat%, Jahr&)
  CALL EpakteJul(Jahr&, Epakte%, GZahl%)

  Tag% = 0

  OPEN DN_JULBED$ FOR INPUT AS #1
  WHILE NOT EOF(1) AND Tag% = 0
    INPUT #1, gz%, mMonat%, mTag%, Laenge%, Modus%, EpakteMrz%, Monat%, MName$

    'Jahreswechsel
    IF mMonat% - sMonat% > 10 THEN
      mJahr& = Jahr& - 1: gz% = gz% + 1: IF gz% = 20 THEN gz% = 1
    ELSE
      mJahr& = Jahr&
    END IF

    IF gz% = GZahl% THEN
      CALL DatumEingabeUmrechnen(mTag%, mMonat%, mJahr&, "EJ", JD1&, 0)
      IF Jahr& MOD 4 = 0 THEN 'Schaltjahr
        IF (Modus% AND 1) = 1 THEN Laenge% = Laenge% + 1
        IF (Modus% AND 16) = 16 THEN JD1& = JD1& + 1
      END IF

      IF JD& >= JD1& AND JD& < JD1& + Laenge% THEN
        Tag% = (JD& - JD1&) + 1
      END IF
    END IF

  WEND
  CLOSE #1
END SUB

SUB GregorMondName(JD&, MMonat%, MName$, GZahl%)
  'sm% = Schaltmonat mnr% = Monatsnummer

  'Computistische Monatsnamen
  IF OsterKalDat% = 1 OR OsterKalDat% = 2 THEN
    CALL GregorMond(JD&, MTag%, MMonat%, 0, 0, 0, 0)
    t% = 30 - MTag%
    'Der Monat hat 29 oder 30 Tage
    WHILE Test% = 0
      CALL GregorMond(JD& + t%, TTag%, TMonat%, 0, 0, 0, 0)
      IF TMonat% <> MMonat% THEN Test% = 1: t% = t% - 1 ELSE t% = t% + 1
    WEND
    CALL JultageGregorian(JD& + t%, 0, Monat%, 0)
    CALL LeseMonatsname("STANDARD.MON", Monat%, MName$, 0)
    MName$ =UCASE$( LEFT$(MName$, 3)): IF Monat% = 3 THEN MName$ = "MRZ"
    'MName$ = "M-" + Monatsname$
    IF MMonat% = 13 THEN MName$ = MName$ + "*"
    CALL JultageGregorian (JD& - MTag%, 0, TMonat%, 0)
    IF TMonat% = Monat% THEN MName$ = MName$ + "#"
  END IF

  'Babylonische Monatsnamen
'  IF OsterKalDat% = 1 THEN
'    CALL JultageGregorian(JD&, GTag%, GMonat%, GJahr&)
'    CALL OstergrenzeGreg (GJahr&, OGrenze%)
'    CALL DatumEingabeUmrechnen(1, 1, GJahr&, "EI", JDS&, 0)
'    CALL GregorMond(JDS& + OGrenze%, 0, TMonat%, 0, 0, 0, 0)
'    IF TMonat% = 4 THEN MMonat% = MMonat% - 3 ELSE MMonat% = MMonat% - 2
'    'Wenn der Monat vor dem Monat der Ostergrenze liegt, im Vorjahr nachschauen
'    IF JD& <= JDS& + OGrenze% - 14 THEN
'      GJahr& = GJahr& - 1
'      IF (GJahr& MOD 4 = 0 AND GJahr& MOD 100 <> 0) OR GJahr& MOD 400 = 0 THEN vgl% = 90 ELSE vgl% = 89 'Max. Ostergrenze bei Mondschaltjahren
'      CALL OstergrenzeGreg (GJahr&, OGrenze%)
'      IF OGrenze% > vgl% THEN vgl% = 12 ELSE vgl% = 13
'      SELECT CASE MMonat%
'        CASE  0: MMonat% = vgl%
'        CASE -1: MMonat% = vgl% - 1
'        CASE -2: MMonat% = vgl% - 2
'        CASE ELSE
'          'Wenn der Mondmonat den 1. Januar berschneidet im Vorjahr am 31.12. nachschauen
'          CALL DatumEingabeUmrechnen(1, 1, GJahr&, "EI", JDS&, 0)
'          CALL GregorMond(JDS& + OGrenze%, 0, TMonat%, 0, 0, 0, 0)
'          CALL DatumEingabeUmrechnen(31, 12, GJahr&, "EI", JDS&, 0)
'          CALL GregorMond(JDS&, 0, MMonat%, 0, 0, 0, 0)
'          IF TMonat% = 4 THEN MMonat% = MMonat% - 3 ELSE MMonat% = MMonat% - 2
'      END SELECT
'    END IF
'    CALL LeseMonatsname("GREBABYL.MON", MMonat%, OstermondnameGreg$, 0)
'    MName$ = OstermondnameGreg$ + STR$(MMonat%)
'  END IF
END SUB

SUB MissaleMonatLaengen(Jahr&, Epakte%, GZahl%, ml%())
  '31 Tage knnen im Schaltjahr im Monat 2 und
  'in den Jahren mit vollen Jahrhunderten beim Sonnenangleich entstehen (3.1. 3100)
  'wenn der Vormonat 29 Tage hat und sich Sonnen und Mondangleichung nicht aufheben.
  IF Epakte% = 25 AND GZahl% > 11 THEN Ausnahme% = 1
  IF Jahr& < 1 THEN a& = Jahr& + 1 ELSE a& = Jahr&
  IF (Epakte% > 24 OR Epakte% = 0) AND Ausnahme% = 0 THEN
    s% = 30
    FOR t% = 1 TO 13
      ml%(t%) = s%: IF s% = 30 THEN s% = 29 ELSE s% = 30
    NEXT t%
    IF GZahl% = 19 THEN ml%(13) = 29
    IF (a& MOD 4 = 0 AND a& MOD 100 <> 0) OR a& MOD 400 = 0 THEN ml%(2) = 30
  END IF
  IF Epakte% > 19 AND Epakte% < 25 OR Ausnahme% THEN
    s% = 29
    FOR t% = 1 TO 13
      ml%(t%) = s%: IF s% = 30 THEN s% = 29 ELSE s% = 30
    NEXT t%
    IF GZahl% <> 19 THEN ml%(13) = 30
    IF (a& MOD 4 = 0 AND a& MOD 100 <> 0) OR a& MOD 400 = 0 THEN ml%(2) = 31
  END IF
  IF Epakte% > 0 AND Epakte% < 20 THEN
    s% = 29
    FOR t% = 1 TO 12
      ml%(t%) = s%: IF s% = 30 THEN s% = 29 ELSE s% = 30
    NEXT t%
    ml%(13) = 0
    IF GZahl% = 19 THEN ml%(12) = 29
    IF (a& MOD 4 = 0 AND a& MOD 100 <> 0) OR a& MOD 400 = 0 THEN ml%(2) = 31
  END IF
  'Schalttag am 24. Februar
  IF Epakte% > 0 AND Epakte% < 5 THEN
    IF (a& MOD 4 = 0 AND a& MOD 100 <> 0) OR a& MOD 400 = 0 THEN ml%(1) = 30: ml%(2) = 30
  END IF

  'Sonnenangleichung
  CALL EpakteGreg(Jahr& + 1, ep1%, 0)
  IF Epakte% = 20 AND ep1% = 0 THEN ml%(13) = 0: ml%(12) = 31 'Sonnenangleichungen bei Epakte 20 Schaltmonat entfllt
  IF ABS(Epakte% - ep1%) MOD 10 = 0 THEN
    IF ml%(13) = 0 THEN ml%(12) = 31 ELSE ml%(13) = 31
  END IF
  'IF OsterKalDat% = 1 THEN CALL SchalttageLichtenberg(Jahr&, ml%())
END SUB

'SUB SchalttageLichtenberg(Jahr&, ml%())
'   FOR t% = 2 TO 13
'     IF ml%(t%) = 31 THEN ml%(t%) = 30: ml%(t% - 1) = 30
'   NEXT t%
'END SUB

SUB GregorMond(JD&, Tag%, Monat%, Jahr&, GZahl%, Epakte%, OGrenze%)
  IF JD& < 39 THEN EXIT SUB
  DIM ml%(13)
  CALL JultageGregorian (JD&, 0, 0, Jahr&)
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EI", JD1&, 0)
  Tag% = JD& - JD1& + 1

  'nach Ostern, wenn der Tag im Jahr zwischen dem 21.3 und 25.4. liegt, schauen
  IF Tag% > 79 AND Tag% < 118 THEN 'nur
    CALL OstergrenzeGreg (Jahr&, OGrenze%): og% = OGrenze%
    IF Tag% = OGrenze% + 1 THEN OGrenze% = 1 ELSE OGrenze% = 0
  END IF

  CALL EpakteGreg(Jahr&, Epakte%, GZahl%)
  CALL MissaleMonatLaengen(Jahr&, Epakte%, GZahl%, ml%())

  mz% = 30 - Epakte%: Monat% = 0
  IF Epakte% = 0 THEN mz% = 0
  WHILE Tag% > mz% AND Monat% < 13
    Tag% = Tag% - mz%
    Monat% = Monat% + 1
    mz% = ml%(Monat%)
  WEND

  'Im Vorjahr nachschauen
  IF Monat% = 0 THEN
    Jahr& = Jahr& - 1: IF Jahr& = 0 THEN Jahr& = -1
    CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EI", JD2&, 0)
    CALL DatumEingabeUmrechnen(31, 12, Jahr&, "EI", JD3&, 0)
    TagVJ% = JD3& - JD2& + 1
    CALL EpakteGreg(Jahr&, EpakteVJ%, GZahlVJ%)
    CALL MissaleMonatLaengen(Jahr&, EpakteVJ%, GZahlVJ%, ml%())
    mz% = 30 - EpakteVJ%: MonatVJ% = 0
    IF EpakteVJ% = 0 THEN mz% = 0
    WHILE TagVJ% > mz%
      TagVJ% = TagVJ% - mz%
      MonatVJ% = MonatVJ% + 1
      mz% = ml%(MonatVJ%)
    WEND
    Tag% = Tag% + TagVJ%
    IF EpakteVJ% > 19 OR EpakteVJ% = 0 THEN Monat% = 13 ELSE Monat% = 12
    IF GZahl% = 1 AND Epakte% = 1 THEN Monat% = 13 'Beim bergang von Ep.19 auf Ep.1 Schaltmonat einfgen da der Monatsanfang vom 1.1. auf den 31.12. fllt.
  END IF
  ERASE ml%
END SUB

SUB Illuminaten(JD&, Tag%, Monat%, Jahr&)
  CALL JultageGregDatum (JD&, Tag%, Monat%, Jahr&)
  IF Monat% = 4 THEN Tag% = Tag% + 11
  IF Monat% = 3 AND Tag% > 20 THEN Tag% = Tag% - 20: Monat% = 4
  Jahr& = Jahr& - 630
  IF Monat% < 4 THEN Jahr& = Jahr& - 1
  Monat% = Monat% - 3: IF Monat% < 1 THEN Monat% = Monat% + 12
END SUB

SUB Wilson(JD&, Tag%, Monat%, MName$, Jahr&)
  CALL JultageGregDatum (JD&, Tag%, Monat%, Jahr&)
  'CALL GregdatumJultage (1, 1, Jahr&, JDS&)
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
  Tag% = (JD& - JDS& + 1) MOD 73
  IF Monatstage%(2) = 29 AND JD& - JDS& > 59 THEN Tag% = Tag% - 1
  IF Tag% < 1 THEN Tag% = Tag% + 73
  Monat% = INT((JD& - JDS&) / 73) + 1: IF Monat% = 6 THEN Monat% = 5
  IF Monatstage%(2) = 29 AND Tag% = 73 AND JD& - JDS& < 365 THEN Monat% = Monat% - 1
  Jahr& = Jahr& + 4000
  IF Monatstage%(2) = 29 AND JD& - JDS& = 59 THEN Monat% = 6: Tag% = 0
  CALL LeseMonatsname("WILSON.MON", Monat%, MName$, 0)
END SUB

SUB Datumssprung(JD&, Start&, pm$, Test%)
  STATIC Txt1$, Txt2$, Txt3$
  Test% = 0

  IF (pm$ = "*" OR pm$ = "/") AND (Txt1$ <> "" OR Txt2$ <> "" OR Txt3$ <> "") THEN
    IF pm$ = "*" THEN s% = 1: ELSE s% = -1
    NJD& = ABS(VAL(Txt1$)): NMonat& = ABS(VAL(Txt2$)): NJahr& = ABS(VAL(Txt3$))
    CALL Sprungberechnung(JD&, s%, NMonat&, NJahr&, NJD&, Test%)
    IF Test% = 0 THEN Start& = NJD&: Test% = 1: EXIT SUB
  END IF

  IF pm$ = "+" OR pm$ = "*" THEN Nummer% = 1 ELSE Nummer% = 2
  CALL diawin (2, Spalte%, 11, 37, " Datumssprung ", %ON)
  CALL diaradio (2, 2, " ", 2, 10, "Vor:Zurck ", Nummer%)
  CALL diainpf (6, 2, "Tag:", 6, 6, %N, 7, 0, Txt1$)
  CALL diainpf (6, 14, "Monat:", 6, 20, %N, 5, 0, Txt2$)
  CALL diainpf (6, 26, "Jahr:", 6, 31, %N, 4, 0, Txt3$)
  CALL diapush (8, 23, "bernehmen")
  CALL diapush (8, 2, "Abbruch")
  CALL diaset(2)
  DO
    d% = dialog
    l% = lastkeyx
    IF Nummer% = 2 THEN s% = -1 ELSE s% = 1
    IF d% = 6 OR l% = %ESC THEN
      CALL diaclose: mouseon: EXIT SUB
    ELSEIF d% = 5 AND l% = %ENTER THEN
      NJD& = ABS(VAL(Txt1$)): NMonat& = ABS(VAL(Txt2$)): NJahr& = ABS(VAL(Txt3$))
      CALL Sprungberechnung(JD&, s%, NMonat&, NJahr&, NJD&, Test%)
      IF Test% = 0 THEN Start& = NJD&: CALL diaclose: mouseon: Test% = 1: EXIT SUB
    ELSEIF d% = 2 THEN
      NJD& = ABS(VAL(Txt1$))
    ELSEIF d% = 3 THEN
      NMonat& = ABS(VAL(Txt2$))
    ELSEIF d% = 4 THEN
      NJahr& = ABS(VAL(Txt3$))
    END IF
  LOOP
END SUB

SUB Sprungberechnung(JD&, s%, NMonat&, NJahr&, NJD&, Test%)
  Test% = 0
  CALL JultageGregdatum(JD&, 0, 0, AJahr&)
  CALL JultageGregdatum(JD& + NJD& * s%, Tag%, Monat%, Jahr&)
  IF NJahr& THEN Jahr& = Jahr& + NJahr& * s%
  IF NMonat& THEN
    Jahr& = Jahr& + FIX(NMonat& * s% / 12)
    NMonat& = NMonat& - INT(NMonat& / 12) * 12
    Monat% = Monat% + NMonat& * s%
    IF Monat% < 1 THEN  Monat% = Monat% + 12: Jahr& = Jahr& - 1
    IF Monat% > 12 THEN  Monat% = Monat% - 12: Jahr& = Jahr& + 1
  END IF
  IF Tag% > Monatstage%(Monat%) THEN Tag% = Monatstage%(Monat%) 'z.B Sprung + 1 Monat vom 31.1. auf den 28.2.
  IF (AJahr& < 1 AND Jahr& > -1) OR AJahr& > -1 AND Jahr& < 1 THEN Jahr& = Jahr& + 1 * s% 'Das Jahr 0
  CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "Datum", NJD&, 0)
  IF NJD& = JD& THEN Test% = 1
END SUB

SUB JultageGriechisch (JD&, ATag%, GrTag%, Dekade%, GrMonat%, GrJahr1&, GrJahr2&)
 'Das Olympiadenjahr 1438171 = 1. Juli -776 Beginn der Olympiadenrechnung
 GrJahr1& = INT((JD& - 1438171) / 1460.968796)
 GrJahr2& = INT((JD& - 1438171 - GrJahr1& * 1460.968796) / 365.242199) + 1
 IF GrJahr1& > -1 THEN GrJahr1& = GrJahr1& + 1
 'Volle Zyklusse
 a& = JD& - AeraGriechisch&
 'IF a& < 1 THEN a& = a& - 2 'wegen der Mondangleichung
 'a& = a& - INT(a& / 2922) * 1.528409916 'Mondangleichung
 a& = a& - INT(a& / 2922) * 2922 + 1
 'Volle Jahre
 FOR t% = 1 TO 8
   IF t% = 3 OR t% = 5 OR t% = 8 THEN j% = 384 ELSE j% = 354
   IF a& > j% THEN a& = a& - j% ELSE EXIT FOR
 NEXT t%
 'Volle Monate
 m% = 30
 FOR t% = 1 TO 13
   IF a& > m% THEN a& = a& - m% ELSE GrTag% = a&: EXIT FOR
   IF m% = 30 THEN m% = 29 ELSE m% = 30
   IF t% = 6 THEN
     IF j% = 384 THEN m% = 30 ELSE m% = 0
   END IF
   IF t% = 7 THEN m% = 30
 NEXT t%
 GrMonat% = t%: Dekade% = 1
 ATag% = GrTag%: IF m% = 29 AND ATag% = 29 THEN ATag% = 30 'Fr den Namen am letzetn Monatstag
 IF GrTag% > 10 AND GrTag% < 21 THEN GrTag% = GrTag% - 10: Dekade% = 2
 IF GrTag% > 20 THEN GrTag% = GrTag% - 31: Dekade% = 3
 IF m% = 29 AND GrTag% = -2 THEN GrTag% = -1
END SUB

SUB GriechischeEpoche
 diainputsize% = 7 'sichbare Eingabelnge
 Epoche$ = LTRIM$(STR$(AeraGriechisch&)): merke& = AeraGriechisch&
 CALL diawin (2, Spalte%, 7, 38, " Altgriechische Epoche (JD) ", %ON)
 CALL diainp (2, 7, "Epoche......:", 2, 22, 7, Epoche$)
 CALL diapush (4, 23, "bernehmen")
 CALL diapush (4, 2, "Abbruch")
 CALL diaset (1)
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 3 THEN AeraGriechisch& = merke&: CALL diaclose : mouseon : EXIT SUB
   IF d% = 2 AND l% = %ENTER THEN
     ETest& = VAL(Epoche$)
     IF Epoche$ = "" THEN CALL Fehlermeldung ("91"): Test% = 1
     IF ETest& < 1 THEN CALL Fehlermeldung ("98"): Test% = 1
     IF ETest& > 3218554 THEN CALL Fehlermeldung ("99"): Test% = 1
     IF Test% = 0 THEN AeraGriechisch& = ETest&: EXIT LOOP
   END IF
   IF Test% <> 0 THEN CALL diaset (Test%)
 LOOP
 CALL diaclose : mouseon
END SUB

SUB BabylonischeEpoche
 diainputsize% = 7 'sichbare Eingabelnge
 Epoche$ = LTRIM$(STR$(AeraBabylonisch&)): merke& = AeraBabylonisch&
 CALL diawin (2, Spalte%, 7, 38, " Babylonische Epoche (JD) ", %ON)
 CALL diainp (2, 7, "Epoche......:", 2, 22, 7, Epoche$)
 CALL diapush (4, 23, "bernehmen")
 CALL diapush (4, 2, "Abbruch")
 CALL diaset (1)
 DO
   d% = dialog
   l% = lastkeyx
   Test% = 0
   IF l% = %ESC OR d% = 3 THEN AeraBabylonisch& = merke&: CALL diaclose : mouseon : EXIT SUB
   IF d% = 2 AND l% = %ENTER THEN
     ETest& = VAL(Epoche$)
     IF Epoche$ = "" THEN CALL Fehlermeldung ("91"): Test% = 1
     IF ETest& < 1 THEN CALL Fehlermeldung ("98"): Test% = 1
     IF ETest& > 3218554 THEN CALL Fehlermeldung ("99"): Test% = 1
     IF Test% = 0 THEN AeraBabylonisch& = ETest&: EXIT LOOP
   END IF
   IF Test% <> 0 THEN CALL diaset (Test%)
 LOOP
 CALL diaclose : mouseon
END SUB

SUB LeseMonatsname_2(Nummer%, Monat$)
  'Fr die zustzlichen Montasnamen
  OPEN Monatsnamedatei$ FOR INPUT AS #1
  FOR t% = 0 TO Nummer%
    LINE INPUT #1, Monat$
  NEXT t%
  CLOSE #1
END SUB

SUB LeseMonatsname(Pfadname$, Nummer%, Monat$, Modus%)
  'Modus% = 1 dann 1. eintrag = berschrift
  IF LEFT$(Pfadname$, 6) <> "NAMEN\" THEN Pfadname$ = "NAMEN\" + Pfadname$
  IF RIGHT$(Pfadname$, 4) <> ".MON" THEN Pfadname$ = Pfadname$ +".MON"
  t% = Start%
  OPEN Pfadname$ FOR INPUT AS #1
  IF Modus% = 1 THEN LINE INPUT #1, a$
  WHILE (t% < Nummer%) AND (NOT EOF (1))
    LINE INPUT #1, Monat$
    t% = t% + 1
  WEND
  CLOSE #1
END SUB

SUB JultageOttoman(JD&, OTag%, OMonat%, JMonat%, OJahr&)
  IF JD& < 2333461 OR OttomanDat% = 1 THEN
    CALL JultageOttoman_1(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' vor dem 1. Sept. 1679 jul.
  ELSEIF (JD& > 2333460 AND JD& < 2374915) OR OttomanDat% = 2 THEN
    CALL JultageOttoman_2(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' vor dem 1. Mrz 1790 jul.
  ELSEIF (JD& > 2374914 AND JD& < 2404866) OR OttomanDat% = 3 THEN
    CALL JultageOttoman_3(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' vor dem 1. Mrz 1872 jul.
  ELSEIF (JD& > 2404865 AND JD& < 2421289) OR OttomanDat% = 4 THEN
    CALL JultageOttoman_4(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' vor dem 1. Mrz 1917 greg.
  ELSEIF (JD& > 2421288 AND JD& < 2424517) OR OttomanDat% = 5 THEN
    CALL JultageOttoman_5(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' vor dem 1. Jan. 1925 greg.
  ELSEIF JD& > 2424516 OR OttomanDat% = 6 THEN
    CALL JultageOttoman_6(JD&, OTag%, OMonat%, JMonat%, OJahr&) ' ab dem 1. Jan. 1925 greg.
  END IF
END SUB

SUB JultageOttoman_1(JD&, OTag%, OMonat%, JMonat%, OJahr&)
  CALL JultageJuldatum (JD&, OTag%, JMonat%, JJahr&)
  OMonat% = JMonat% - 8: IF OMonat% < 1 THEN OMonat% = OMonat% + 12
  IF OMonat% < 5 THEN JJahr& = JJahr& + 1
  CALL DatumEingabeUmrechnen(2, 3, JJahr&, "EJ", JDT&, 0) 'Julianischer Tag des 2. Juli = 183. Tag
  CALL JultageMoham (JDT&, MTag%, MMonat%, OJahr&)' Das Jahr vom Islamischen bernehmen
END SUB

SUB JultageOttoman_2(JD&, OTag%, OMonat%, JMonat%, OJahr&)
  CALL JultageJuldatum (JD&, OTag%, JMonat%, JJahr&)
  OMonat% = JMonat% - 2: IF OMonat% < 1 THEN OMonat% = OMonat% + 12
  IF OMonat% > 10 THEN JJahr& = JJahr& - 1
  CALL DatumEingabeUmrechnen(31, 8, JJahr&, "EJ", JDT&, 0) 'Julianischer Tag des 31. August = 183. Tag
  CALL JultageMoham (JDT&, MTag%, MMonat%, OJahr&)' Das Jahr vom Islamischen Kalender bernehmen
END SUB

SUB JultageOttoman_3(JD&, OTag%, OMonat%, JMonat%, OJahr&)
  CALL JultageJuldatum (JD&, OTag%, JMonat%, JJahr&)
  OMonat% = JMonat% - 2: IF OMonat% < 1 THEN OMonat% = OMonat% + 12
  IF OMonat% > 10 THEN JJahr& = JJahr& - 1
  CALL DatumEingabeUmrechnen(1, 3, JJahr&, "EJ", JDT&, 0) 'Julianischer Tag de 1. Mrz
  CALL JultageMoham (JDT&, MTag%, MMonat%, OJahr&)' Das Jahr vom Islamischen Kalender bernehmen
END SUB

SUB JultageOttoman_4(JD&, OTag%, OMonat%, JMonat%, OJahr&)
  CALL JultageJuldatum (JD&, OTag%, JMonat%, JJahr&)
  OMonat% = JMonat% - 2: IF OMonat% < 1 THEN OMonat% = OMonat% + 12
  IF OMonat% > 10 THEN JJahr& = JJahr& - 1
  OJahr& = JJahr& - 584
END SUB

SUB JultageOttoman_5(JD&, OTag%, OMonat%, GMonat%, OJahr&)
  CALL JultageGregorian(JD&, OTag%, GMonat%, GJahr&)
  OMonat% = GMonat% - 2: IF OMonat% < 1 THEN OMonat% = OMonat% + 12
  IF OMonat% > 10 THEN GJahr& = GJahr& - 1
  OJahr& = GJahr& - 584
END SUB

SUB JultageOttoman_6(JD&, OTag%, OMonat%, GMonat%, OJahr&)
  CALL JultageGregorian(JD&, OTag%, GMonat%, OJahr&)
  OMonat% = GMonat%
END SUB

SUB DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, Kal$, JD&, Test%)
  maxi& = 3218554: mini& = 0
  Datum& = 10000 * Jahr& + Monat% * 100 + Tag%: Test% = 1

  DO
    JD& = (maxi& + mini&) / 2
    CALL HoleDatum(JD&, VTag%, VMonat%, VJahr&, Kal$, Datum&)
    Vergleich& = 10000 * VJahr& + VMonat% * 100 + VTag%
    IF Vergleich& > Datum& THEN maxi& = JD&
    IF Vergleich& < Datum& THEN mini& = JD&
    IF Vergleich& = Datum& THEN Test% = 0
  LOOP WHILE Vergleich& <> Datum& AND maxi& - mini& > 1

  'Fr den Julianischen Kalender bei Jahreswechsel nicht am 1.1.
  IF Vergleich& <> Datum& THEN
    JD& = JD& - 367
    WHILE Vergleich& <> Datum& AND t& < 733
      t& = t& + 1
      CALL HoleDatum(JD& + t&, VTag%, VMonat%, VJahr&, Kal$, 0)
      Vergleich& = 10000 * VJahr& + VMonat% * 100 + VTag%
    WEND
    IF Vergleich& = Datum& THEN Test% = 0: JD& = JD& + t&
  END IF

  IF maxi& = 1 AND mini& = 0 THEN JD& = 0: Test% = 3
  IF maxi& = 3218554 AND mini& = 3218553 THEN JD& = 3218554: Test% = 2 'Bereich berschritten
END SUB

SUB DatumEingabe_olympisch(Text$, Datum$, JD&, Test%, Kal$)
  Test% = 0
  CALL Texteingabe_t (Datum$, sz$, Text$, 6)
  IF sz$ = CHR$(27) THEN EXIT SUB
  FOR t% = 1 TO LEN(Datum$)
    'Text "0"-"9" und "-" aussortieren und nach a$ umschreiben
    IF (MID$(Datum$, t%, 1) > CHR$(47) AND MID$(Datum$, t%, 1) < CHR$(58)) OR MID$(Datum$, t%, 1) = CHR$(45) THEN
      a$ = a$ + MID$(Datum$, t%, 1)
    ELSE
      GrJahr1& = VAL(a$) : a$ = ""
      IF GrJahr1& > 1219 THEN GrJahr1& = 1219: f% = 1
      IF GrJahr1& < -985 THEN GrJahr1& = -985: f% = 1
      IF GrJahr1& = 0 THEN GrJahr1& = 1: f% = 1
    END IF
  NEXT t%
  GrJahr2& = VAL(a$)
  IF GrJahr2& > 4 THEN GrJahr2& = 4: f% = 2
  IF GrJahr2& < 1 THEN GrJahr2& = 1: f% = 2
  SELECT CASE f%
    CASE 1: c$ = "115"
    CASE 2: c$ = "116"
  END SELECT
  IF f% THEN CALL Fehlermeldung(c$)
  Jahr& = GrJahr1& * 10 + GrJahr2&
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, Kal$, JD&, Test%)
  IF Test% = 1 THEN CALL Fehlermeldung("87")
  IF Test% = 2 THEN CALL Fehlermeldung("89")
  IF Test% = 3 THEN CALL Fehlermeldung("114")
  Test% = 1
END SUB

SUB DatumEingabe_neu(Text$, Datum$, JD&, Test%, Kal$)
  Test% = 0
  IF Kal$ = "Datum" THEN Modus% = 0 ELSE Modus% = 1'Zweistellige Eingabe
  CALL Texteingabe_t (Datum$, sz$, Text$, 11)
  IF sz$ = CHR$(27) THEN EXIT SUB
  CALL DatumWandel(Datum$, Tag%, Monat%, Jahr&, Modus%)
  IF Kal$ = "EE" THEN 'Fr den Badi-Kalender
    IF Monat% = 19 THEN Monat% = 20
    IF Monat% = 0 THEN Monat% = 19
  END IF
  CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, Kal$, JD&, Test%)
  IF Test% = 0 THEN Datum$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)) + "." + LTRIM$(STR$(Jahr&))
  IF Test% = 1 THEN CALL Fehlermeldung("87")
  IF Test% = 2 THEN CALL Fehlermeldung("89")
  IF Test% = 3 THEN CALL Fehlermeldung("114")
  Test% = 1
END SUB

SUB DatumTest(Test%, Tag%, Monat%, Jahr&)
 IF Jahr& * 10000 + Monat% * 100 + Tag% <= DatJulGreg& THEN
   CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "EJ", JD&, Test%)
 ELSE
   CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "EI", JD&, Test%)
 END IF
END SUB

SUB HoleDatum(JD&, Tag%, Monat%, Jahr&, Kal$, Datum&)
  SELECT CASE Kal$
    CASE "Datum"
      IF Datum& <= DatJulGreg& THEN
        CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
      ELSE
        CALL JultageGregorian(JD&, Tag%, Monat%, Jahr&)
      END IF
    CASE "EW": CALL JultageOttoman(JD&, Tag%, Monat%, 0, Jahr&)
    CASE "EQ": CALL JultageKhayam(JD&, Tag%, Monat%, Jahr&)
    CASE "ID": CALL JultageKurdisch(JD&, Tag%, Monat%, Jahr&)
    CASE "EM": CALL JultageMoham(JD&, Tag%, Monat%, Jahr&)
    CASE "EI": CALL JultageGregorian(JD&, Tag%, Monat%, Jahr&)
    CASE "EJ": CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
    CASE "EJE": CALL JultageJuldatumAera(JD&, Tag%, Monat%, Jahr&): CALL JulJahresanfang(Tag%, Monat%, Jahr&)
    CASE "EH": CALL JultageJuddatum(JD&, Tag%, Monat%, Jahr&, 0)
    CASE "EA": CALL JultageAegypt(JD&, Tag%, Monat%, Jahr&, 0)
    CASE "EG": CALL JultageKoptdatum(JD&, Tag%, Monat%, Jahr&)
    CASE "EU": CALL JultageAethopisch(JD&, Tag%, Monat%, Jahr&)
    CASE "EF": CALL JultageFranzdatum(JD&, Tag%, Monat%, Jahr&)
    CASE "OX": CALL JultageJazdagird (JD&, Tag%, Monat%, Jahr&)
    CASE "OZ": CALL JultageGelal (JD&, Tag%, Monat%, Jahr&)
    CASE "OTB": CALL JultageBabylonisch (JD&, Tag%, Monat%, Jahr&)
    CASE "EX": CALL JultageWelt(JD&, Tag%, Monat%, Jahr&, 0)
    CASE "EY": CALL Illuminaten(JD&, Tag%, Monat%, Jahr&)
    CASE "EZ": CALL Wilson(JD&, Tag%, Monat%, "", Jahr&)
    CASE "QT": CALL JultageArmenisch (JD&, Tag%, Monat%, Jahr&)
    CASE "OT": CALL JultageGriechisch(JD&, 0, 0, 0, 0, GrJahr1&, GrJahr2&): Jahr& = GrJahr1& * 10 + GrJahr2&: Monat% = 1: Tag% = 1
    CASE "EE": CALL JultageBadidatum (JD&, Tag%, Monat%, Jahr&, 0, 0)
    CASE "QY": CALL JulianMond(JD&, Tag%, Monat%, Jahr&, 0, 0, 0, 0, "")
    CASE "QU": CALL GregorMond(JD&, Tag%, Monat%, Jahr&, 0, 0, 0)
    'CASE "QV": CALL GregorMond(JD&, Tag%, Monat%, Jahr&, 0, 0, 0)': CALL GregorMondName(JD&, Monat%, "", 0)
  END SELECT
END SUB

SUB DatumAstronomischOstern(Text$, JDO&, Test%)
  DO
    CALL Texteingabe_t (Datum$, sz$, Text$, 4)
    IF sz$ = CHR$(27) THEN Test% = 0: EXIT SUB
    Jahr& = VAL(Datum$)
    CALL DatumEingabeUmrechnen(1, 3, Jahr&, "Datum", JD&, Test%)
    IF Test% = 2 THEN CALL Fehlermeldung("89")
    'IF Test% = 3 THEN CALL Fehlermeldung("114")
  LOOP WHILE Test%
  CALL AstronomischOstern(JD&, JDO&) 'Astronomisch Ostern
  Test% = 1
END SUB

$SEGMENT

SUB FesttagEingabe(JD&, Test%)
 CALL diawin (2, Spalte%, 24, 38, " Datumseingabe nach Feststag ", %ON)
 'Eintrge zhlen
 OPEN DN_FTAGEING$ FOR INPUT AS #1
 WHILE NOT EOF(1)
   z% = z% + 1
   LINE INPUT #1, a$
 WEND
 CLOSE #1
 'Eintrge laden
 DIM Marke$(z%), TagesNr%(z%), FestTagName$(z%): Tage$ ="0"
 OPEN DN_FTAGEING$ FOR INPUT AS #1
 FOR t% = 1 TO z%
   INPUT # 1, Marke$(t%), TagesNr%(t%), FestTagName$(t%)
 NEXT t%
 CLOSE #1
 'Dialog ffnen
 CALL diainp (2, 2, " ", 2, 4, 7, Tage$): CALL diaprint(2, 12, "Tag(e)")
 CALL diaradio (2, 25, " ", 2, 25, "Vor:Nach", VorNach%)
 dialistmax% = 13
 CALL dialistbox (5, 2, " ", 5, 2, 33, FestTagName$(1), Auswahl%, %FALSE)
 CALL diainp (19, 6, "Im Jahr:", 19, 15, 16, Jahr$)
 CALL diapush (21, 23, "bernehmen")
 CALL diapush (21, 14, "Info")
 CALL diapush (21, 2, "Abbruch")
 CALL diaset(1)

 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 7 THEN
     Test% = 0: EXIT LOOP
   ELSEIF d% = 6 THEN
     CALL LeseDateiName(DN_INFO$, 48, Infodatei$): CALL Kalenderinfo
   ELSEIF d% = 5 AND l% = %ENTER THEN
     Test% = 1: EXIT LOOP
   END IF
 LOOP

 'Jahr feststellen
 IF Test% <> 0 THEN
   Zahl% = VAL(Jahr$)
   IF Zahl% = 0 AND LEN(Jahr$) > 0 THEN CALL RoemischZahl(Jahr$, Zahl%)
   IF Zahl% = 0 THEN CALL Fehlermeldung("117"): Test% = 0: ELSE FJahr& = Zahl%
   IF Jahr& > 4099 OR Jahr& < -4713 THEN CALL Fehlermeldung("114"): Test% = 0
 END IF

 IF Test% <> 0 THEN
   'Tagesdifferenz
   tk% = VAL(Tage$)
   IF tk% = 0 AND Tage$ <> "0" AND LEN(Tage$) > 0 THEN CALL RoemischZahl(Tage$, tk%)
   IF VorNach% < 2 THEN tk% = tk% * -1
   'Jahrestag
   IF Marke$(Auswahl%) = "j" THEN
     Monat% = INT(TagesNr%(Auswahl%) / 100): Tag% = TagesNr%(Auswahl%) - Monat% * 100
     CALL DatumEingabeUmrechnen(Tag%, Monat%, FJahr&, "Datum", JD&, 0)
     JD& = JD& + tk%
   END IF
   'Ostern
   IF Marke$(Auswahl%) = "o" THEN
     CALL DatumEingabeUmrechnen(1, 1, FJahr&, "Datum", JD&, 0)
     CALL Datum_Kalenderreform(FJahr&, Umstelldatum&)
     IF JD& < Umstelldatum& THEN CALL OstersonntagJul(FJahr&, Ostern%) ELSE CALL OstersonntagGreg(FJahr&, Ostern%)
     JD& = JD& + Ostern% + TagesNr%(Auswahl%) + tk%
   END IF
   'Advent
   IF Marke$(Auswahl%) = "a" THEN
     CALL DatumEingabeUmrechnen(1, 1, FJahr&, "Datum", JD&, 0)
     CALL DatumEingabeUmrechnen(27, 11, FJahr&, "Datum", JD2&, 0)
     CALL Wochentag(0, 0, 0, JD2&, wt%)
     Advent% = JD2& - JD& + 7 - wt%
     JD& = JD& + Advent% + TagesNr%(Auswahl%) + tk%
   END IF
 END IF
 ERASE Marke$, TagesNr%, FestTagName$
 CALL diaclose: mouseon
END SUB

SUB RoemischeEingabe(Start&, JD&, Test%)

 CALL diawin (2, Spalte%, 20, 39, " Rmische Datierung ", %ON)
 'Das aktuelle Datum
 CALL JultageGregdatum (Start&, Tag%, Monat%, Jahr&)

 CALL RoemischerTag (Start&, "", 0, "", Kurzform$)
 l% = INSTR(Kurzform$, " ") + 1: IF l% = 1 THEN l% = LEN(Kurzform$)
 Kurzform$ = UCASE$(LEFT$(Kurzform$, l%))
 IF RIGHT$(Kurzform$, 1) = "K" OR Tag% > 15 THEN Monat% = Monat% + 1: IF Monat% = 13 THEN Monat% = 1

 jz% = Jahr&
 CALL ZahlRoemisch(jz%, Jahr$, 1)

 'Eintrge laden
 DIM RoemTagName$(34)
 OPEN DN_ROMTAG_F$ FOR INPUT AS #1
 FOR t% = 1 TO 34
   INPUT# 1, RoemTagName$(t%)
   IF UCASE$(LEFT$(RoemTagName$(t%), LEN(Kurzform$))) = Kurzform$ THEN
     IF Auswahl% = 0 THEN Auswahl% = t%
     IF Kurzform$ = "PRIDIE" AND Tag% > t% THEN Auswahl% = 0
   END IF
 NEXT t%
 CLOSE #1

 OPEN DN_STANDARD$ FOR INPUT AS #1
 FOR t% = 1 TO 12
   INPUT #1, a$
   Monatsnamen$ = Monatsnamen$ + a$
   IF t% < 12 THEN Monatsnamen$ = Monatsnamen$ + ":"
 NEXT t%
 CLOSE #1

 'Dialog ffnen
 dialistmax% = 12
 diainputsize% = 16
 CALL dialistbox (2, 2, " ", 2, 2, 16, RoemTagName$(1), Auswahl%, %FALSE)
 CALL diaradio (2, 22, " ", 2, 22, Monatsnamen$, Monat%)
 CALL diainp (15, 2, "Jahr:", 15, 8, 16, Jahr$)
 CALL diapush (17, 24, "bernehmen")
 CALL diapush (17, 14, "Info")
 CALL diapush (17, 2, "Abbruch")

 DO

   DO
    d% = dialog
     l% = lastkeyx
     IF l% = %ESC OR d% = 6 THEN
       Test% = 0: ERASE RoemTagName$: CALL diaclose: mouseon: EXIT SUB
     ELSEIF d% = 5 THEN
       CALL LeseDateiName(DN_INFO$, 49, Infodatei$): CALL Kalenderinfo
     ELSEIF d% = 4 AND l% = %ENTER THEN
       Test% = 1: EXIT LOOP
     END IF
   LOOP

   'Jahr feststellen
   Zahl% = VAL(Jahr$)
   IF Zahl% = 0 AND LEN(Jahr$) > 0 THEN CALL RoemischZahl(Jahr$, Zahl%)
   IF Zahl% = 0 THEN Test% = 7: ELSE Jahr& = Zahl%
   IF Jahr& > 4099 THEN Test% = 8
   IF Jahr& < -4713 THEN Test% = 9

   Tag% = Auswahl%
   IF Auswahl% > 30 THEN Tag% = Tag% - 1 'Schalttag
   IF Auswahl% = 30 THEN Test% = 2

   SELECT CASE Monat%
     CASE 1, 2, 9
       IF Auswahl% = 2 OR Auswahl% = 3 THEN Test% = 3
       IF Auswahl% > 3 THEN Tag% = Tag% - 2
     CASE 3
       CALL Schaltjahr(1, 1, Jahr&)
       IF Auswahl% > 15 AND Auswahl% < 19 THEN Test% = 4
       IF Auswahl% > 18 THEN Tag% = Tag% - 5
       IF Auswahl% = 30 AND Monatstage%(2) = 29 THEN Test% = 1
       IF Auswahl% > 30 AND Monatstage%(2) = 29 THEN Tag% = Tag% + 1
     CASE 4, 6, 8, 11
       IF Auswahl% = 2 OR Auswahl% = 3 THEN Test% = 3
       IF Auswahl% > 3 THEN Tag% = Tag% - 2
       IF Auswahl% = 16 OR Auswahl% = 17 THEN Test% = 5
     CASE 5, 7, 10
       IF Auswahl% = 16 THEN Test% = 6
       IF Auswahl% > 16 THEN Tag% = Tag% - 3
     CASE 12
       IF Auswahl% = 2 OR Auswahl% = 3 THEN Test% = 3
       IF Auswahl% > 3 THEN Tag% = Tag% - 2
       IF Auswahl% = 16 THEN Test% = 6
       IF Auswahl% > 16 THEN Tag% = Tag% - 1
   END SELECT

   IF Test% > 1 THEN
     IF Test% = 2 THEN CALL Fehlermeldung("118")
     IF Test% = 3 THEN CALL Fehlermeldung("127")
     IF Test% = 4 THEN CALL Fehlermeldung("128")
     IF Test% = 5 THEN CALL Fehlermeldung("129")
     IF Test% = 6 THEN CALL Fehlermeldung("130")
     IF Test% = 7 THEN CALL Fehlermeldung("117")
     IF Test% = 8 THEN CALL Fehlermeldung("89")
     IF Test% = 9 THEN CALL Fehlermeldung("114")
     Test% = 0
   END IF
 LOOP WHILE Test% = 0

 IF Auswahl% > 15 THEN Monat% = Monat% - 1: IF Monat% < 1 THEN Monat% = 12
 CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "Datum", JD&, 0)
 ERASE RoemTagName$
 CALL diaclose: mouseon
END SUB

SUB WaehleAusListe(LName$, LUeberschrift$, InfoNr%, JD&, Test%)
 l% = LEN(LUeberschrift$)
 'Eintrge zhlen
 OPEN LName$ FOR INPUT AS #1
 WHILE NOT EOF(1)
   z% = z% + 1
   LINE INPUT #1, a$
 WEND
 CLOSE #1
 'Eintrge laden
 DIM LPfad$(z%), LTitel$(z% + 1), LDatum&(z%)
 OPEN LName$ FOR INPUT AS #1
 FOR t% = 1 TO z%
   INPUT #1, LPfad$(t%)
   OPEN LPfad$(t%) FOR INPUT AS #2
   IF LName$ = DN_SANKTORA$ THEN
     LINE INPUT #2, LTitel$(t%)
     LTitel$(t%) = RIGHT$(LTitel$(t%), LEN(LTitel$(t%)) - 4)
     IF Auswahl% = 0 THEN Auswahl% = Sankto%
   END IF
   IF LName$ = DN_FINSTERN$ THEN
     INPUT #2, LDatum&(t%)
     IF LDatum&(t%) <= JD& THEN Auswahl% = t%
     LINE INPUT #2, LTitel$(t%)
   END IF
   IF LName$ = DN_HERRSCHE$ THEN
     INPUT #2, ha%, hb%, LTitel$(t%)
     IF LPfad$(t%) = Herrkal$ THEN Auswahl% = t%
   END IF
   IF LName$ = DN_MONATNAM$ THEN
     LINE INPUT #2, LTitel$(t%)
     IF MonatsnameNr% THEN Auswahl% = MonatsnameNr%
   END IF
   IF LName$ = DN_JULMONAT$ THEN
     LINE INPUT #2, LTitel$(t%)
     IF JulMonatsnameNr% THEN Auswahl% = JulMonatsnameNr%
   END IF
   IF LName$ = DN_KOPMONAT$ THEN
     LINE INPUT #2, LTitel$(t%)
     IF KopMonatsnameNr% THEN Auswahl% = KopMonatsnameNr%
   END IF
   IF LName$ = DN_FERIENLI$ THEN
     LINE INPUT #2, LTitel$(t%)
     IF Ferien% THEN Auswahl% = Ferien%
   END IF
   CLOSE #2
   IF LEN(LTitel$(t%)) > l%  AND LEN(LTitel$(t%)) < 73 THEN l% = LEN(LTitel$(t%))
 NEXT t%
 CLOSE #1

 IF l% < 38 THEN l% = 38
 CALL diawin (2, Spalte%, 24, l% + 5, LUeberschrift$, %ON)

 'Dialog ffnen
 dialistmax% = 18
 CALL dialistbox (2, 2, " ", 2, 2, l%, LTitel$(1), Auswahl%, %FALSE)
 CALL diapush (21, l% - 10, "bernehmen")
 CALL diapush (21, l% / 2 - 2, "Info")
 CALL diapush (21, 2, "Abbruch")
 CALL diaset(1)

 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 4 THEN
     Test% = 0: EXIT LOOP
   ELSEIF d% = 3 THEN
     CALL LeseDateiName(DN_INFO$, InfoNr%, Infodatei$): CALL Kalenderinfo
   ELSEIF d% = 2 AND l% = %ENTER THEN
     Test% = 1
     IF LName$ = DN_HERRSCHE$ THEN CALL LeseDateiName(DN_HERRSCHE$, Auswahl%, Herrkal$): EXIT LOOP
     IF LName$ = DN_SANKTORA$ THEN Sankto% = Auswahl%: CALL ListeTextAusgabe(LPfad$(Auswahl%), LName$)
     IF LName$ = DN_FINSTERN$ THEN JD& = LDatum&(Auswahl%): CALL ListeTextAusgabe(LPfad$(Auswahl%), LName$)
     IF LName$ = DN_MONATNAM$ THEN MonatsnameNr% = Auswahl%: Monatsnamedatei$ = LPfad$(Auswahl%)
     IF LName$ = DN_JULMONAT$ THEN JulMonatsnameNr% = Auswahl%: JulMonatsnamedatei$ = LPfad$(Auswahl%)
     IF LName$ = DN_KOPMONAT$ THEN KopMonatsnameNr% = Auswahl%: KopMonatsnamedatei$ = LPfad$(Auswahl%)
     IF LName$ = DN_FERIENLI$ THEN Ferien% = Auswahl%: Feriendateiname$ = LPfad$(Auswahl%)
     EXIT LOOP
   END IF
 LOOP

 ERASE LPfad$, LTitel$, LDatum&
 CALL diaclose: mouseon
END SUB

SUB ListeTextAusgabe(LPfad$, LName$)
 OPEN LPfad$ FOR INPUT AS #2
 IF LName$ = DN_FINSTERN$ THEN
   INPUT #2, b&
   LINE INPUT #2, Text$
   WHILE NOT EOF(2)
     LINE INPUT #2, a$
     CALL TextAufbereitung(a$, 76, x%, y%, m%)
     IF NOT m% THEN m% = 1
   WEND
 END IF
 IF LName$ = DN_SANKTORA$ THEN
   LINE INPUT #2, Text$
   LINE INPUT #2, a$
   Text$ = RIGHT$(Text$, LEN(Text$) - 4)
   a$ = RIGHT$(a$, LEN(a$) - 4)
   CALL TextAufbereitung(a$, 76, x%, y%, 0)
 END IF
 CLOSE #2
 CALL InfoTextAusgabe(" " + Text$ + " ", x% , y%, 0)
END SUB




























































