SUB AstronomischOstern(JD&, JDO&)
 CALL Jahreszeit(JD&, JDE#, 0, 3) 'Frhling
 JDE# = JDE# + 2.34778 / 24 'Ortszeit Jerusalem
 CALL Vollmond(INT(JDE#), JDM&, JDV#)
 IF JDE# > JDV# THEN CALL Vollmond(INT(JDE#) + 28, JDM&, JDV#) 'Uhrzeit des Frhlings ist spter
 CALL Wochentag (0, 0, 0, JDM&, wt%)
 IF wt% = 7 THEN JDO& = JDM& + 7 ELSE JDO& = JDM& + 7 - wt%
END SUB

SUB Vollmond(JD&, JD_vm&, JDE_vm#)
 'Fr die astronomische Osterberechnung
 '2.34778 / 24 = Ortszeit Jerusalem
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
 IF Jahr& < 0 THEN Jahr& = Jahr& + 1 'das Jahr Null hinzurechnen
 t% = 0
 WHILE JD_vm& < JD&
   k_vm# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685) + .5
   CALL Mondphase_Vollmondkorrekturen(k_vm#, JDE_vm#)
   CALL Mondphase_Zusatzkorrekturen(k_vm#, JDE_vm#)
   JDE_vm# = JDE_vm# + 2.34778 / 24 'Ortszeit Jerusalem
   CALL JulTageZeit (JDE_vm#, s%, m%, h%, JD_vm&)
   t% = t% + 1
 WEND
END SUB

SUB OsterGrenzeJul (Jahr&, OGrenze%)
 CALL EpakteJul(Jahr&, Epakte%, gz%)
 OGrenze% = 31 - Epakte% + 13 - 1 'Vollmond im Januar
 a& = Jahr&: IF a& < 1 THEN a& = a& + 1
 IF a& MOD 4 = 0 THEN Feb% = 29 ELSE Feb% = 28
 IF Feb% = 29 THEN OGrenze% = OGrenze% + 1 'Schalttag im Mondkalender einrechnen
 t% = 30
 WHILE OGrenze% < 31 + Feb% + 20
   OGrenze% = OGrenze% + t%
   IF t% = 30 THEN t% = 29 ELSE t% = 30 'Monatslnge wechseln
 WEND
END SUB

SUB OstergrenzeGreg (Jahr&, OGrenze%)
 IF Jahr& < 1 THEN a& = Jahr& + 1 ELSE a& = Jahr&
 IF (a& MOD 4 = 0 AND a& MOD 100 <> 0) OR a& MOD 400 = 0 THEN Februar% = 29 ELSE Februar% = 28
 CALL EpakteGreg(Jahr&, Epakte%, gz%)

 OGrenze% = 30 - Epakte% + 13 'Vollmond im Januar
 IF Februar% = 29 THEN OGrenze% = OGrenze% + 1 'Schalttag im Mondkalender einrechnen
 t% = 30
 WHILE OGrenze% < 31 + Februar% + 20
   OGrenze% = OGrenze% + t%
   IF t% = 30 THEN t% = 29 ELSE t% = 30 'Monatslnge der Mondmonate wechseln
 WEND

 '1. Ausnahme: 19.4. wird zum 18.4, damit Ostern nicht auf den 26. fllt
 IF OGrenze% = 80 + Februar% THEN OGrenze% = OGrenze% - 1: EXIT SUB

 '2. Ausnahme: 18.4 wird zum 17.4 wenn Goldenen Zahl > 11, damit in einem Zyklus (GZ 1-19) Ostern nicht zweimal am 25.4 ist
 IF OGrenze% = 79 + Februar% AND gz% > 11 THEN OGrenze% = OGrenze% - 1
END SUB

SUB OstersonntagGreg(Jahr&, Ostersonntag%)
 'Tage zum Ostersonntag ab 1. Januar
 CALL OstergrenzeGreg (Jahr&, OGrenze%)
 'CALL GregorianJultage(1, 1, Jahr&, JD&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EI", JD&, 0)
 CALL Wochentag (0, 0, 0, JD& + OGrenze%, wt%)
 IF wt% = 7 THEN Ostersonntag% = OGrenze% + 7 ELSE  Ostersonntag% = OGrenze% + 7 - wt%
END SUB

SUB OstersonntagJul(Jahr&, Ostersonntag%)
 'Tage zum Ostersonntag ab 1. Januar
 CALL OstergrenzeJul (Jahr&, OGrenze%)
 'CALL JuldatumJultage (1, 1, Jahr&, JD&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", JD&, 0)
 CALL Wochentag (0, 0, 0, JD& + OGrenze%, wt%)
 IF wt% = 7 THEN Ostersonntag% = OGrenze% + 7 ELSE  Ostersonntag% = OGrenze% + 7 - wt%
END SUB

SUB EpakteGreg(Jahr&, Epakte%, gz%)
  gz% = (Jahr& + 1) MOD 19
  IF gz% < 1 THEN gz% = gz% + 19
  IF Jahr& < 1 THEN gz% = gz% + 1
  IF gz% > 19 THEN gz% = gz% - 19
  j& = INT(Jahr& / 100) + 1
  x% = INT(j& * 3 / 4) - 12
  z% = INT((j& * 8 + 5) / 25) - 5
  Epakte% = (gz% * 11 + 20 + z% - x%) MOD 30
  IF Epakte% < 0 THEN Epakte% = Epakte% + 30
END SUB

SUB EpakteJul(Jahr&, Epakte%, gz%)
  'gz% = Jahr im Mondzyklus von 1 - 19
  'Epakte% von 0 bis 29
  gz% = (Jahr& + 1) MOD 19
  IF gz% < 1 THEN gz% = gz% + 19
  IF Jahr& < 1 THEN gz% = gz% + 1
  IF gz% > 19 THEN gz% = gz% - 19
  'Epakte = Alter des Mondes am 1. Januar
  Epakte% = (gz% * 11 - 3) MOD 30
  IF Epakte% < 0 THEN Epakte% = Epakte% + 30
END SUB

SUB Sonntagsbuchstabe(Jahr&, Kal$, sb$)
   'Kal$ = "EJ" = julianisch
   'Kal$ = "EI" = gregorianisch
   CALL DatumEingabeUmrechnen(1, 1, Jahr&, Kal$, JD&, 0)
   CALL Wochentag(0, 0, 0, JD&, wt%)
   sb$ = CHR$(97 + 7 - wt%)
   IF (Kal$ = "EJ" AND Jahr& MOD 4 = 0) OR (Kal$ = "EI" AND (Jahr& MOD 4 = 0 AND Jahr& MOD 100 <> 0) OR (Jahr& MOD 400 = 0)) THEN sb$ = sb$ + CHR$(97 + 6 - wt%)
   REPLACE "a" WITH "A" IN sb$
   REPLACE "`" WITH "g" IN sb$
END SUB

SUB WTKonkurrent(Jahr&, Kal$, ko$)
  'Kal$ = "EJ" = julianisch
  'Kal$ = "EI" = gregorianisch
   CALL DatumEingabeUmrechnen(1, 1, Jahr&, Kal$, JD&, 0)
   CALL Wochentag(0, 0, 0, JD&, wt%)
   wt% = 8 - wt%
   CALL ZahlRoemisch (wt%, ko$, 2)
   IF (Kal$ = "EJ" AND Jahr& MOD 4 = 0) OR (Kal$ = "EI" AND (Jahr& MOD 4 = 0 AND Jahr& MOD 100 <> 0) OR (Jahr& MOD 400 = 0)) THEN
     wt% = wt% - 1: IF wt% = 0 THEN wt% = 7
     CALL ZahlRoemisch (wt%, ko2$, 2): ko$ = ko$ + " und " + ko2$
   END IF
END SUB

